=== modified file 'Makefile'
--- Makefile	2009-06-19 13:12:39 +0000
+++ Makefile	2010-02-14 19:58:58 +0000
@@ -3,38 +3,34 @@
 # Makefile fragment for Linux 2.6
 # Broadcom 802.11abg Networking Device Driver
 #
-# Copyright 2008, Broadcom Corporation
+# Copyright (C) 2010, Broadcom Corporation
 # All Rights Reserved.
 # 
-#      Unless you and Broadcom execute a separate written software license
-# agreement governing use of this software, this software is licensed to you
-# under the terms of the GNU General Public License version 2, available at
-# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
-# following added to such license:
-#      As a special exception, the copyright holders of this software give you
-# permission to link this software with independent modules, regardless of the
-# license terms of these independent modules, and to copy and distribute the
-# resulting executable under terms of your choice, provided that you also meet,
-# for each linked independent module, the terms and conditions of the license
-# of that module. An independent module is a module which is not derived from
-# this software.
-# 
 # This is UNPUBLISHED PROPRIETARY SOURCE CODE of Broadcom Corporation;
 # the contents of this file may not be disclosed to third parties, copied
 # or duplicated in any form, in whole or in part, without the prior
 # written permission of Broadcom Corporation.
 #
-# $Id: Makefile_kbuild_portsrc,v 1.1.2.4 2008/05/02 18:33:39 Exp $
+# $Id: Makefile_kbuild_portsrc,v 1.5.4.1 2009/08/13 21:37:18 Exp $
 
 obj-m              += wl.o
 
 wl-objs            := 
+wl-objs            += src/shared/linux_osl.o
 wl-objs            += src/wl/sys/wl_linux.o
 wl-objs            += src/wl/sys/wl_iw.o
-wl-objs            += src/shared/linux_osl.o
 
 EXTRA_CFLAGS       :=
 EXTRA_CFLAGS       += -I$(src)/src/include
-EXTRA_CFLAGS       += -I$(src)/src/wl/sys
+EXTRA_CFLAGS       += -I$(src)/src/wl/sys -I$(src)/src/wl/phy
 
 EXTRA_LDFLAGS      := $(src)/lib/wlc_hybrid.o_shipped
+
+all:
+	KBUILD_NOPEDANTIC=1 make -C /lib/modules/`uname -r`/build M=`pwd`
+
+clean:
+	KBUILD_NOPEDANTIC=1 make -C /lib/modules/`uname -r`/build M=`pwd` clean
+
+install:
+	install -D -m 755 wl.ko /lib/modules/`uname -r`/kernel/drivers/net/wireless/wl.ko

=== modified file 'README'
--- README	2009-05-11 16:04:29 +0000
+++ README	2010-02-14 19:58:58 +0000
@@ -1,2 +1,2 @@
-This project is  a DKMS package for the Broadcom wireless
+This project is a DKMS package for the Broadcom wireless
 driver found at http://www.broadcom.com/support/802.11/linux_sta.php.

=== modified file 'src/lib/LICENSE.txt' (properties changed: -x to +x)
--- src/lib/LICENSE.txt	2009-05-11 16:04:29 +0000
+++ src/lib/LICENSE.txt	2010-02-14 19:58:58 +0000
@@ -1,4 +1,3 @@
-
 SOFTWARE LICENSE AGREEMENT
 
 Unless you and Broadcom Corporation (Broadcom) execute a separate written software license agreement governing use of the accompanying software, this software is licensed to you under the terms of this Software License Agreement (Agreement).  

=== modified file 'src/lib/wlc_hybrid.o_shipped_i386'
Binary files src/lib/wlc_hybrid.o_shipped_i386 and src/lib/wlc_hybrid.o_shipped_i386 differ
=== modified file 'src/lib/wlc_hybrid.o_shipped_x86_64'
Binary files src/lib/wlc_hybrid.o_shipped_x86_64 and src/lib/wlc_hybrid.o_shipped_x86_64 differ
=== modified file 'src/src/include/bcmdefs.h'
--- src/src/include/bcmdefs.h	2009-05-11 16:04:29 +0000
+++ src/src/include/bcmdefs.h	2010-02-14 19:58:58 +0000
@@ -1,28 +1,15 @@
 /*
  * Misc system wide definitions
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: bcmdefs.h,v 13.43.2.11 2009/02/11 01:59:34 Exp $
+ * $Id: bcmdefs.h,v 13.61 2009/04/01 18:59:11 Exp $
  */
 
 #ifndef	_bcmdefs_h_
@@ -40,7 +27,14 @@
 #define BCMFASTPATH
 
 #define BCMROMDATA(_data)	_data
+#define BCMROMDAT_NAME(_data)	_data
 #define BCMROMFN(_fn)		_fn
+#define BCMROMFN_NAME(_fn)	_fn
+#define STATIC	static
+#define BCMROMDAT_ARYSIZ(data)	ARRAYSIZE(data)
+#define BCMROMDAT_SIZEOF(data)	sizeof(data)
+#define BCMROMDAT_APATCH(data)
+#define BCMROMDAT_SPATCH(data)
 
 #define	SI_BUS			0	
 #define	PCI_BUS			1	
@@ -120,12 +114,16 @@
 } hnddma_seg_map_t;
 
 #if defined(BCM_RPC_NOCOPY) || defined(BCM_RCP_TXNOCOPY)
+
 #define BCMEXTRAHDROOM 220
 #else
 #define BCMEXTRAHDROOM 172
 #endif
 
 #define BCMDONGLEHDRSZ 12
+#define BCMDONGLEPADSZ 16
+
+#define BCMDONGLEOVERHEAD	(BCMDONGLEHDRSZ + BCMDONGLEPADSZ)
 
 #ifdef BCMDBG
 

=== modified file 'src/src/include/bcmendian.h'
--- src/src/include/bcmendian.h	2009-05-11 16:04:29 +0000
+++ src/src/include/bcmendian.h	2010-02-14 19:58:58 +0000
@@ -1,29 +1,19 @@
 /*
- * local version of endian.h - byte order defines
+ * Byte order utilities
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- *  $Id: bcmendian.h,v 1.31 2005/09/03 22:24:22 Exp $
-*/
+ *  $Id: bcmendian.h,v 1.34 2008/09/17 22:52:25 Exp $
+ *
+ * This file by default provides proper behavior on little-endian architectures.
+ * On big-endian architectures, IL_BIGENDIAN should be defined.
+ */
 
 #ifndef _BCMENDIAN_H_
 #define _BCMENDIAN_H_
@@ -31,21 +21,18 @@
 #include <typedefs.h>
 
 #define BCMSWAP16(val) \
-	((uint16)(\
-		(((uint16)(val) & (uint16)0x00ffU) << 8) | \
-		(((uint16)(val) & (uint16)0xff00U) >> 8)))
+	((uint16)((((uint16)(val) & (uint16)0x00ffU) << 8) | \
+		  (((uint16)(val) & (uint16)0xff00U) >> 8)))
 
 #define BCMSWAP32(val) \
-	((uint32)(\
-		(((uint32)(val) & (uint32)0x000000ffUL) << 24) | \
-		(((uint32)(val) & (uint32)0x0000ff00UL) <<  8) | \
-		(((uint32)(val) & (uint32)0x00ff0000UL) >>  8) | \
-		(((uint32)(val) & (uint32)0xff000000UL) >> 24)))
+	((uint32)((((uint32)(val) & (uint32)0x000000ffU) << 24) | \
+		  (((uint32)(val) & (uint32)0x0000ff00U) <<  8) | \
+		  (((uint32)(val) & (uint32)0x00ff0000U) >>  8) | \
+		  (((uint32)(val) & (uint32)0xff000000U) >> 24)))
 
 #define BCMSWAP32BY16(val) \
-	((uint32)(\
-		(((uint32)(val) & (uint32)0x0000ffffUL) << 16) | \
-		(((uint32)(val) & (uint32)0xffff0000UL) >> 16)))
+	((uint32)((((uint32)(val) & (uint32)0x0000ffffU) << 16) | \
+		  (((uint32)(val) & (uint32)0xffff0000U) >> 16)))
 
 static INLINE uint16
 bcmswap16(uint16 val)
@@ -68,7 +55,7 @@
 static INLINE void
 bcmswap16_buf(uint16 *buf, uint len)
 {
-	len = len/2;
+	len = len / 2;
 
 	while (len--) {
 		*buf = bcmswap16(*buf);
@@ -79,12 +66,19 @@
 #ifndef hton16
 #define HTON16(i) BCMSWAP16(i)
 #define	hton16(i) bcmswap16(i)
+#define	HTON32(i) BCMSWAP32(i)
 #define	hton32(i) bcmswap32(i)
+#define	NTOH16(i) BCMSWAP16(i)
 #define	ntoh16(i) bcmswap16(i)
+#define	NTOH32(i) BCMSWAP32(i)
 #define	ntoh32(i) bcmswap32(i)
+#define LTOH16(i) (i)
 #define ltoh16(i) (i)
+#define LTOH32(i) (i)
 #define ltoh32(i) (i)
+#define HTOL16(i) (i)
 #define htol16(i) (i)
+#define HTOL32(i) (i)
 #define htol32(i) (i)
 #endif 
 
@@ -94,71 +88,74 @@
 static INLINE void
 htol16_ua_store(uint16 val, uint8 *bytes)
 {
-	bytes[0] = val&0xff;
-	bytes[1] = val>>8;
+	bytes[0] = val & 0xff;
+	bytes[1] = val >> 8;
 }
 
 static INLINE void
 htol32_ua_store(uint32 val, uint8 *bytes)
 {
-	bytes[0] = val&0xff;
-	bytes[1] = (val>>8)&0xff;
-	bytes[2] = (val>>16)&0xff;
-	bytes[3] = val>>24;
+	bytes[0] = val & 0xff;
+	bytes[1] = (val >> 8) & 0xff;
+	bytes[2] = (val >> 16) & 0xff;
+	bytes[3] = val >> 24;
 }
 
 static INLINE void
 hton16_ua_store(uint16 val, uint8 *bytes)
 {
-	bytes[1] = val&0xff;
-	bytes[0] = val>>8;
+	bytes[0] = val >> 8;
+	bytes[1] = val & 0xff;
 }
 
 static INLINE void
 hton32_ua_store(uint32 val, uint8 *bytes)
 {
-	bytes[3] = val&0xff;
-	bytes[2] = (val>>8)&0xff;
-	bytes[1] = (val>>16)&0xff;
-	bytes[0] = val>>24;
-}
-
-static INLINE uint16
-ltoh16_ua(void *bytes)
-{
-	return (((uint8*)bytes)[1]<<8)+((uint8 *)bytes)[0];
-}
-
-static INLINE uint32
-ltoh32_ua(void *bytes)
-{
-	return (((uint8*)bytes)[3]<<24)+(((uint8*)bytes)[2]<<16)+
-	       (((uint8*)bytes)[1]<<8)+((uint8*)bytes)[0];
-}
-
-static INLINE uint16
-ntoh16_ua(void *bytes)
-{
-	return (((uint8*)bytes)[0]<<8)+((uint8*)bytes)[1];
-}
-
-static INLINE uint32
-ntoh32_ua(void *bytes)
-{
-	return (((uint8*)bytes)[0]<<24)+(((uint8*)bytes)[1]<<16)+
-	       (((uint8*)bytes)[2]<<8)+((uint8*)bytes)[3];
-}
-
-#define ltoh_ua(ptr) (\
-	sizeof(*(ptr)) == sizeof(uint8) ?  *(uint8 *)ptr : \
-	sizeof(*(ptr)) == sizeof(uint16) ? (((uint8 *)ptr)[1]<<8)+((uint8 *)ptr)[0] : \
-	(((uint8 *)ptr)[3]<<24)+(((uint8 *)ptr)[2]<<16)+(((uint8 *)ptr)[1]<<8)+((uint8 *)ptr)[0] \
-)
-
-#define ntoh_ua(ptr) (\
-	sizeof(*(ptr)) == sizeof(uint8) ?  *(uint8 *)ptr : \
-	sizeof(*(ptr)) == sizeof(uint16) ? (((uint8 *)ptr)[0]<<8)+((uint8 *)ptr)[1] : \
-	(((uint8 *)ptr)[0]<<24)+(((uint8 *)ptr)[1]<<16)+(((uint8 *)ptr)[2]<<8)+((uint8 *)ptr)[3] \
-)
+	bytes[0] = val >> 24;
+	bytes[1] = (val >> 16) & 0xff;
+	bytes[2] = (val >> 8) & 0xff;
+	bytes[3] = val & 0xff;
+}
+
+#define _LTOH16_UA(cp)	((cp)[0] | ((cp)[1] << 8))
+#define _LTOH32_UA(cp)	((cp)[0] | ((cp)[1] << 8) | ((cp)[2] << 16) | ((cp)[3] << 24))
+#define _NTOH16_UA(cp)	(((cp)[0] << 8) | (cp)[1])
+#define _NTOH32_UA(cp)	(((cp)[0] << 24) | ((cp)[1] << 16) | ((cp)[2] << 8) | (cp)[3])
+
+static INLINE uint16
+ltoh16_ua(const void *bytes)
+{
+	return _LTOH16_UA((const uint8 *)bytes);
+}
+
+static INLINE uint32
+ltoh32_ua(const void *bytes)
+{
+	return _LTOH32_UA((const uint8 *)bytes);
+}
+
+static INLINE uint16
+ntoh16_ua(const void *bytes)
+{
+	return _NTOH16_UA((const uint8 *)bytes);
+}
+
+static INLINE uint32
+ntoh32_ua(const void *bytes)
+{
+	return _NTOH32_UA((const uint8 *)bytes);
+}
+
+#define ltoh_ua(ptr) \
+	(sizeof(*(ptr)) == sizeof(uint8) ? *(const uint8 *)ptr : \
+	 sizeof(*(ptr)) == sizeof(uint16) ? _LTOH16_UA((const uint8 *)ptr) : \
+	 sizeof(*(ptr)) == sizeof(uint32) ? _LTOH32_UA((const uint8 *)ptr) : \
+	 0xfeedf00d)
+
+#define ntoh_ua(ptr) \
+	(sizeof(*(ptr)) == sizeof(uint8) ? *(const uint8 *)ptr : \
+	 sizeof(*(ptr)) == sizeof(uint16) ? _NTOH16_UA((const uint8 *)ptr) : \
+	 sizeof(*(ptr)) == sizeof(uint32) ? _NTOH32_UA((const uint8 *)ptr) : \
+	 0xfeedf00d)
 
 #endif 

=== modified file 'src/src/include/bcmutils.h'
--- src/src/include/bcmutils.h	2009-05-11 16:04:29 +0000
+++ src/src/include/bcmutils.h	2010-02-14 19:58:58 +0000
@@ -1,33 +1,24 @@
 /*
  * Misc useful os-independent macros and functions.
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: bcmutils.h,v 13.199.2.5 2008/11/25 12:13:46 Exp $
+ * $Id: bcmutils.h,v 13.217 2009/05/14 22:33:52 Exp $
  */
 
 #ifndef	_bcmutils_h_
 #define	_bcmutils_h_
 
+#ifdef __cplusplus
+extern "C" {
+#endif
+
 #define _BCM_U	0x01	
 #define _BCM_L	0x02	
 #define _BCM_D	0x04	
@@ -107,6 +98,8 @@
 
 #define PKTQ_PREC_ITER(pq, prec)        for (prec = (pq)->num_prec - 1; prec >= 0; prec--)
 
+typedef bool (*ifpkt_cb_t)(void*, int);
+
 struct ether_addr;
 
 #define pktq_psetmax(pq, prec, _max)    ((pq)->q[prec].max = (_max))
@@ -123,7 +116,8 @@
 extern void *pktq_pdeq(struct pktq *pq, int prec);
 extern void *pktq_pdeq_tail(struct pktq *pq, int prec);
 
-extern void pktq_pflush(osl_t *osh, struct pktq *pq, int prec, bool dir);
+extern void pktq_pflush(osl_t *osh, struct pktq *pq, int prec, bool dir,
+	ifpkt_cb_t fn, int arg);
 
 extern bool pktq_pdel(struct pktq *pq, void *p, int prec);
 
@@ -148,7 +142,7 @@
 extern void *pktq_deq_tail(struct pktq *pq, int *prec_out);
 extern void *pktq_peek(struct pktq *pq, int *prec_out);
 extern void *pktq_peek_tail(struct pktq *pq, int *prec_out);
-extern void pktq_flush(osl_t *osh, struct pktq *pq, bool dir); 
+extern void pktq_flush(osl_t *osh, struct pktq *pq, bool dir, ifpkt_cb_t fn, int arg);
 
 extern uint pktcopy(osl_t *osh, void *p, uint offset, int len, uchar *buf);
 extern uint pktfrombuf(osl_t *osh, void *p, uint offset, int len, uchar *buf);
@@ -168,6 +162,9 @@
 extern char *BCMROMFN(bcmstrcat)(char *dest, const char *src);
 extern char *BCMROMFN(bcmstrncat)(char *dest, const char *src, uint size);
 extern ulong wchar2ascii(char *abuf, ushort *wbuf, ushort wbuflen, ulong abuflen);
+char* bcmstrtok(char **string, const char *delimiters, char *tokdelim);
+int bcmstricmp(const char *s1, const char *s2);
+int bcmstrnicmp(const char* s1, const char* s2, int cnt);
 
 extern char *bcm_ether_ntoa(const struct ether_addr *ea, char *buf);
 extern int BCMROMFN(bcm_ether_atoe)(char *p, struct ether_addr *ea);
@@ -287,7 +284,7 @@
 #define BCME_NOT_WME_ASSOCIATION	-34	
 #define BCME_SDIO_ERROR			-35	
 #define BCME_DONGLE_DOWN		-36	
-#define BCME_VERSION			-37 	
+#define BCME_VERSION			-37 
 #define BCME_TXFAIL			-38 	
 #define BCME_RXFAIL			-39	
 #define BCME_NODEVICE			-40 	
@@ -445,11 +442,33 @@
 	a[0] = v & 0xff;
 }
 
+static INLINE void
+xor_128bit_block(const uint8 *src1, const uint8 *src2, uint8 *dst)
+{
+	if (
+#ifdef __i386__
+	    1 ||
+#endif
+	    (((uintptr)src1 | (uintptr)src2 | (uintptr)dst) & 3) == 0) {
+
+		((uint32 *)dst)[0] = ((const uint32 *)src1)[0] ^ ((const uint32 *)src2)[0];
+		((uint32 *)dst)[1] = ((const uint32 *)src1)[1] ^ ((const uint32 *)src2)[1];
+		((uint32 *)dst)[2] = ((const uint32 *)src1)[2] ^ ((const uint32 *)src2)[2];
+		((uint32 *)dst)[3] = ((const uint32 *)src1)[3] ^ ((const uint32 *)src2)[3];
+	} else {
+
+		int k;
+		for (k = 0; k < 16; k++)
+			dst[k] = src1[k] ^ src2[k];
+	}
+}
+
 extern uint8 BCMROMFN(hndcrc8)(uint8 *p, uint nbytes, uint8 crc);
 extern uint16 BCMROMFN(hndcrc16)(uint8 *p, uint nbytes, uint16 crc);
 extern uint32 BCMROMFN(hndcrc32)(uint8 *p, uint nbytes, uint32 crc);
 
-#if defined(BCMDBG) || defined(BCMDBG_ERR) || defined(BCMDBG_DUMP)
+#if defined(BCMDBG) || defined(DHD_DEBUG) || defined(BCMDBG_ERR) || \
+	defined(BCMDBG_DUMP)
 extern int bcm_format_flags(const bcm_bit_desc_t *bd, uint32 flags, char* buf, int len);
 extern int bcm_format_hex(char *str, const void *bytes, int len);
 extern void prhex(const char *msg, uchar *buf, uint len);
@@ -484,6 +503,9 @@
 
 extern void bcm_binit(struct bcmstrbuf *b, char *buf, uint size);
 extern int bcm_bprintf(struct bcmstrbuf *b, const char *fmt, ...);
+extern void bcm_inc_bytes(uchar *num, int num_bytes, uint8 amount);
+extern int bcm_cmp_bytes(uchar *arg1, uchar *arg2, uint8 nbytes);
+extern void bcm_print_bytes(char *name, const uchar *cdata, int len);
 
 typedef  uint32 (*bcmutl_rdreg_rtn)(void *arg0, uint arg1, uint32 offset);
 extern uint bcmdumpfields(bcmutl_rdreg_rtn func_ptr, void *arg0, uint arg1, struct fielddesc *str,
@@ -492,4 +514,8 @@
 extern uint bcm_mkiovar(char *name, char *data, uint datalen, char *buf, uint len);
 extern uint BCMROMFN(bcm_bitcount)(uint8 *bitmap, uint bytelength);
 
+#ifdef __cplusplus
+	}
+#endif
+
 #endif	

=== modified file 'src/src/include/bcmwifi.h'
--- src/src/include/bcmwifi.h	2009-05-11 16:04:29 +0000
+++ src/src/include/bcmwifi.h	2010-02-14 19:58:58 +0000
@@ -3,28 +3,15 @@
  * This header file housing the define and function prototype use by
  * both the wl driver, tools & Apps.
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: bcmwifi.h,v 1.19.2.1.54.1 2009/03/25 01:50:55 Exp $
+ * $Id: bcmwifi.h,v 1.24 2009/05/21 21:22:04 Exp $
  */
 
 #ifndef	_bcmwifi_h_
@@ -100,6 +87,7 @@
 #define CHSPEC_CTL_CHAN(chspec)  ((CHSPEC_SB_LOWER(chspec)) ? \
 				  (LOWER_20_SB((chspec & WL_CHANSPEC_CHAN_MASK))) : \
 				  (UPPER_20_SB((chspec & WL_CHANSPEC_CHAN_MASK))))
+#define CHSPEC2WLC_BAND(chspec) (CHSPEC_IS5G((chspec))? WLC_BAND_5G: WLC_BAND_2G)
 
 #define CHANSPEC_STR_LEN    8
 
@@ -127,6 +115,8 @@
 
 extern uint8 wf_chspec_ctlchan(chanspec_t chspec);
 
+extern chanspec_t wf_chspec_ctlchspec(chanspec_t chspec);
+
 extern int wf_mhz2channel(uint freq, uint start_factor);
 
 extern int wf_channel2mhz(uint channel, uint start_factor);

=== modified file 'src/src/include/epivers.h'
--- src/src/include/epivers.h	2009-05-11 16:04:29 +0000
+++ src/src/include/epivers.h	2010-02-14 19:58:58 +0000
@@ -1,26 +1,13 @@
 /*
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: epivers.h.in,v 13.27 2008/02/29 03:29:46 Exp $
+ * $Id: epivers.h.in,v 13.30 2009/05/13 20:12:23 Exp $
  *
 */
 
@@ -29,18 +16,20 @@
 
 #define	EPI_MAJOR_VERSION	5
 
-#define	EPI_MINOR_VERSION	10
-
-#define	EPI_RC_NUMBER		91
-
-#define	EPI_INCREMENTAL_NUMBER	9
-
-#define	EPI_BUILD_NUMBER	0
-
-#define	EPI_VERSION		5, 10, 91, 9
-
-#define	EPI_VERSION_NUM		0x050a5b09
-
-#define	EPI_VERSION_STR		"5.10.91.9"
+#define	EPI_MINOR_VERSION	60
+
+#define	EPI_RC_NUMBER		48
+
+#define	EPI_INCREMENTAL_NUMBER	36
+
+#define EPI_BUILD_NUMBER	2
+
+#define	EPI_VERSION		5, 60, 48, 36
+
+#define	EPI_VERSION_NUM		0x053c3024
+
+#define EPI_VERSION_DEV		5.60.48
+
+#define	EPI_VERSION_STR		"5.60.48.36 "
 
 #endif 

=== modified file 'src/src/include/linux_osl.h'
--- src/src/include/linux_osl.h	2009-05-11 16:04:29 +0000
+++ src/src/include/linux_osl.h	2010-02-14 19:58:58 +0000
@@ -1,28 +1,15 @@
 /*
  * Linux OS Independent Layer
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: linux_osl.h,v 13.133.2.9 2008/12/05 00:54:44 Exp $
+ * $Id: linux_osl.h,v 13.146.6.4 2009/10/21 18:57:23 Exp $
  */
 
 #ifndef _linux_osl_h_
@@ -30,10 +17,14 @@
 
 #include <typedefs.h>
 
+extern void * osl_os_open_image(char * filename);
+extern int osl_os_get_image_block(char * buf, int len, void * image);
+extern void osl_os_close_image(void * image);
+
 extern osl_t *osl_attach(void *pdev, uint bustype, bool pkttag);
 extern void osl_detach(osl_t *osh);
 
-extern bool g_assert_bypass;
+extern uint32 g_assert_type;
 
 #if defined(BCMDBG_ASSERT)
 	#define ASSERT(exp) \
@@ -104,12 +95,12 @@
 extern uint osl_malloc_failed(osl_t *osh);
 
 #define	DMA_CONSISTENT_ALIGN	osl_dma_consistent_align()
-#define	DMA_ALLOC_CONSISTENT(osh, size, pap, dmah) \
-	osl_dma_alloc_consistent((osh), (size), (pap))
+#define	DMA_ALLOC_CONSISTENT(osh, size, align, tot, pap, dmah) \
+	osl_dma_alloc_consistent((osh), (size), (align), (tot), (pap))
 #define	DMA_FREE_CONSISTENT(osh, va, size, pa, dmah) \
 	osl_dma_free_consistent((osh), (void*)(va), (size), (pa))
 extern uint osl_dma_consistent_align(void);
-extern void *osl_dma_alloc_consistent(osl_t *osh, uint size, ulong *pap);
+extern void *osl_dma_alloc_consistent(osl_t *osh, uint size, uint16 align, uint *tot, ulong *pap);
 extern void osl_dma_free_consistent(osl_t *osh, void *va, uint size, ulong pa);
 
 #define	DMA_TX	1	
@@ -127,8 +118,6 @@
 	#define SELECT_BUS_WRITE(osh, mmap_op, bus_op) mmap_op
 	#define SELECT_BUS_READ(osh, mmap_op, bus_op) mmap_op
 
-#define OSL_SYSUPTIME()		(0)
-
 #define OSL_ERROR(bcmerror)	osl_error(bcmerror)
 extern int osl_error(int bcmerror);
 
@@ -243,8 +232,13 @@
 extern void osl_writew(uint16 v, volatile uint16 *r);
 extern void osl_writel(uint32 v, volatile uint32 *r);
 
+#define OSL_SYSUPTIME()		osl_sysuptime()
+extern uint32 osl_sysuptime(void);
+
 #define OSL_UNCACHED(va)	osl_uncached((va))
 extern void *osl_uncached(void *va);
+#define OSL_CACHED(va)		osl_cached((va))
+extern void *osl_cached(void *va);
 
 #define OSL_GETCYCLES(x)	((x) = osl_getcycles())
 extern uint osl_getcycles(void);

=== modified file 'src/src/include/linuxver.h'
--- src/src/include/linuxver.h	2009-05-11 16:04:29 +0000
+++ src/src/include/linuxver.h	2010-02-14 19:58:58 +0000
@@ -2,28 +2,15 @@
  * Linux-specific abstractions to gain some independence from linux kernel versions.
  * Pave over some 2.2 versus 2.4 versus 2.6 kernel differences.
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: linuxver.h,v 13.40.2.5 2008/12/15 18:36:58 Exp $
+ * $Id: linuxver.h,v 13.50.22.2 2009/10/02 19:09:49 Exp $
  */
 
 #ifndef _linuxver_h_
@@ -65,6 +52,9 @@
 #include <linux/pci.h>
 #include <linux/interrupt.h>
 #include <linux/netdevice.h>
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 28))
+#undef IP_TOS
+#endif
 #include <asm/io.h>
 
 #if (LINUX_VERSION_CODE > KERNEL_VERSION(2, 5, 41))
@@ -119,6 +109,17 @@
 #define MOD_DEC_USE_COUNT
 #endif 
 
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 29)
+#include <net/lib80211.h>
+#endif
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 30)
+#include <linux/ieee80211.h>
+#else
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 14)
+#include <net/ieee80211.h>
+#endif
+#endif 
+
 #ifndef __exit
 #define __exit
 #endif
@@ -181,6 +182,18 @@
 #endif
 #endif	
 
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 31)
+#define WL_USE_NETDEV_OPS
+#else
+#undef WL_USE_NETDEV_OPS
+#endif
+
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 31)) && defined(CONFIG_RFKILL_INPUT)
+#define WL_CONFIG_RFKILL_INPUT
+#else
+#undef WL_CONFIG_RFKILL_INPUT
+#endif
+
 #if (LINUX_VERSION_CODE < KERNEL_VERSION(2, 3, 48))
 #define list_for_each(pos, head) \
 	for (pos = (head)->next; pos != (head); pos = pos->next)
@@ -289,7 +302,7 @@
 	tasklet->routine = (void (*)(void *))func;
 	tasklet->data = (void *)data;
 }
-#define tasklet_kill(tasklet)	{ do{} while (0); }
+#define tasklet_kill(tasklet)	{ do {} while (0); }
 
 #define del_timer_sync(timer) del_timer(timer)
 
@@ -446,4 +459,30 @@
 
 #endif 
 
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 27))
+#define KILL_PROC(pid, sig) \
+{ \
+	struct task_struct *tsk; \
+	tsk = find_task_by_vpid(pid); \
+	if (tsk) send_sig(sig, tsk, 1); \
+}
+#else
+#define KILL_PROC(pid, sig) \
+{ \
+	kill_proc(pid, sig, 1); \
+}
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 29)
+#define WL_DEV_IF(dev)          ((wl_if_t*)netdev_priv(dev))
+#else
+#define WL_DEV_IF(dev)          ((wl_if_t*)(dev)->priv)
+#endif
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 20)
+#define WL_ISR(i, d, p)         wl_isr((i), (d))
+#else
+#define WL_ISR(i, d, p)         wl_isr((i), (d), (p))
+#endif  
+
 #endif 

=== modified file 'src/src/include/osl.h'
--- src/src/include/osl.h	2009-05-11 16:04:29 +0000
+++ src/src/include/osl.h	2010-02-14 19:58:58 +0000
@@ -1,28 +1,15 @@
 /*
  * OS Abstraction Layer
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: osl.h,v 13.38.2.3 2009/02/26 17:07:08 Exp $
+ * $Id: osl.h,v 13.44 2009/03/02 05:15:20 Exp $
  */
 
 #ifndef _osl_h_
@@ -39,6 +26,14 @@
 
 #define	SET_REG(osh, r, mask, val)	W_REG((osh), (r), ((R_REG((osh), r) & ~(mask)) | (val)))
 
+#ifndef AND_REG
+#define AND_REG(osh, r, v)		W_REG(osh, (r), R_REG(osh, r) & (v))
+#endif   
+
+#ifndef OR_REG
+#define OR_REG(osh, r, v)		W_REG(osh, (r), R_REG(osh, r) | (v))
+#endif   
+
 #if !defined(OSL_SYSUPTIME)
 #define OSL_SYSUPTIME() (0)
 #define OSL_SYSUPTIME_SUPPORT FALSE

=== added file 'src/src/include/packed_section_end.h'
--- src/src/include/packed_section_end.h	1970-01-01 00:00:00 +0000
+++ src/src/include/packed_section_end.h	2010-02-14 19:58:58 +0000
@@ -0,0 +1,35 @@
+/*
+ * Declare directives for structure packing. No padding will be provided
+ * between the members of packed structures, and therefore, there is no
+ * guarantee that structure members will be aligned.
+ *
+ * Declaring packed structures is compiler specific. In order to handle all
+ * cases, packed structures should be delared as:
+ *
+ * #include <packed_section_start.h>
+ *
+ * typedef BWL_PRE_PACKED_STRUCT struct foobar_t {
+ *    some_struct_members;
+ * } BWL_POST_PACKED_STRUCT foobar_t;
+ *
+ * #include <packed_section_end.h>
+ *
+ *
+ * Copyright (C) 2010, Broadcom Corporation
+ * All Rights Reserved.
+ * 
+ * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
+ * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
+ * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
+ * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
+ * $Id: packed_section_end.h,v 1.4 2008/12/09 23:43:22 Exp $
+ */
+
+#ifdef BWL_PACKED_SECTION
+	#undef BWL_PACKED_SECTION
+#else
+	#error "BWL_PACKED_SECTION is NOT defined!"
+#endif
+
+#undef	BWL_PRE_PACKED_STRUCT
+#undef	BWL_POST_PACKED_STRUCT

=== added file 'src/src/include/packed_section_start.h'
--- src/src/include/packed_section_start.h	1970-01-01 00:00:00 +0000
+++ src/src/include/packed_section_start.h	2010-02-14 19:58:58 +0000
@@ -0,0 +1,42 @@
+/*
+ * Declare directives for structure packing. No padding will be provided
+ * between the members of packed structures, and therefore, there is no
+ * guarantee that structure members will be aligned.
+ *
+ * Declaring packed structures is compiler specific. In order to handle all
+ * cases, packed structures should be delared as:
+ *
+ * #include <packed_section_start.h>
+ *
+ * typedef BWL_PRE_PACKED_STRUCT struct foobar_t {
+ *    some_struct_members;
+ * } BWL_POST_PACKED_STRUCT foobar_t;
+ *
+ * #include <packed_section_end.h>
+ *
+ *
+ * Copyright (C) 2010, Broadcom Corporation
+ * All Rights Reserved.
+ * 
+ * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
+ * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
+ * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
+ * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
+ * $Id: packed_section_start.h,v 1.4 2008/12/09 23:43:22 Exp $
+ */
+
+#ifdef BWL_PACKED_SECTION
+	#error "BWL_PACKED_SECTION is already defined!"
+#else
+	#define BWL_PACKED_SECTION
+#endif
+
+#if defined(__GNUC__)
+	#define	BWL_PRE_PACKED_STRUCT
+	#define	BWL_POST_PACKED_STRUCT	__attribute__((packed))
+#elif defined(__CC_ARM)
+	#define	BWL_PRE_PACKED_STRUCT	__packed
+	#define	BWL_POST_PACKED_STRUCT
+#else
+	#error "Unknown compiler!"
+#endif

=== modified file 'src/src/include/pcicfg.h'
--- src/src/include/pcicfg.h	2009-05-11 16:04:29 +0000
+++ src/src/include/pcicfg.h	2010-02-14 19:58:58 +0000
@@ -1,28 +1,15 @@
 /*
  * pcicfg.h: PCI configuration constants and structures.
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: pcicfg.h,v 1.43.2.4 2008/10/13 01:37:28 Exp $
+ * $Id: pcicfg.h,v 1.49.68.1 2009/12/07 20:06:51 Exp $
  */
 
 #ifndef	_h_pcicfg_

=== modified file 'src/src/include/proto/802.11.h'
--- src/src/include/proto/802.11.h	2009-05-11 16:04:29 +0000
+++ src/src/include/proto/802.11.h	2010-02-14 19:58:58 +0000
@@ -1,20 +1,7 @@
 /*
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
@@ -22,7 +9,7 @@
  *
  * Fundamental types and constants relating to 802.11
  *
- * $Id: 802.11.h,v 9.222.2.5 2009/01/28 00:21:34 Exp $
+ * $Id: 802.11.h,v 9.253.2.1 2009/10/22 07:38:43 Exp $
  */
 
 #ifndef _802_11_H_
@@ -38,12 +25,7 @@
 
 #include <proto/wpa.h>
 
-#if defined(__GNUC__)
-#define	PACKED	__attribute__((packed))
-#else
-#pragma pack(1)
-#define	PACKED
-#endif
+#include <packed_section_start.h>
 
 #define DOT11_TU_TO_US			1024	
 
@@ -89,17 +71,17 @@
 
 #define DOT11_LLC_SNAP_HDR_LEN		8	
 #define DOT11_OUI_LEN			3	
-struct dot11_llc_snap_header {
+BWL_PRE_PACKED_STRUCT struct dot11_llc_snap_header {
 	uint8	dsap;				
 	uint8	ssap;				
 	uint8	ctl;				
 	uint8	oui[DOT11_OUI_LEN];		
 	uint16	type;				
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 
 #define RFC1042_HDR_LEN	(ETHER_HDR_LEN + DOT11_LLC_SNAP_HDR_LEN)	
 
-struct dot11_header {
+BWL_PRE_PACKED_STRUCT struct dot11_header {
 	uint16			fc;		
 	uint16			durid;		
 	struct ether_addr	a1;		
@@ -107,46 +89,57 @@
 	struct ether_addr	a3;		
 	uint16			seq;		
 	struct ether_addr	a4;		
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 
-struct dot11_rts_frame {
+BWL_PRE_PACKED_STRUCT struct dot11_rts_frame {
 	uint16			fc;		
 	uint16			durid;		
 	struct ether_addr	ra;		
 	struct ether_addr	ta;		
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 #define	DOT11_RTS_LEN		16		
 
-struct dot11_cts_frame {
+BWL_PRE_PACKED_STRUCT struct dot11_cts_frame {
 	uint16			fc;		
 	uint16			durid;		
 	struct ether_addr	ra;		
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 #define	DOT11_CTS_LEN		10		
 
-struct dot11_ack_frame {
+BWL_PRE_PACKED_STRUCT struct dot11_ack_frame {
 	uint16			fc;		
 	uint16			durid;		
 	struct ether_addr	ra;		
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 #define	DOT11_ACK_LEN		10		
 
-struct dot11_ps_poll_frame {
+BWL_PRE_PACKED_STRUCT struct dot11_ps_poll_frame {
 	uint16			fc;		
 	uint16			durid;		
 	struct ether_addr	bssid;		
 	struct ether_addr	ta;		
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 #define	DOT11_PS_POLL_LEN	16		
 
-struct dot11_cf_end_frame {
+BWL_PRE_PACKED_STRUCT struct dot11_cf_end_frame {
 	uint16			fc;		
 	uint16			durid;		
 	struct ether_addr	ra;		
 	struct ether_addr	bssid;		
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 #define	DOT11_CS_END_LEN	16		
 
+BWL_PRE_PACKED_STRUCT struct dot11_action_wifi_vendor_specific {
+	uint8	category;
+	uint8	OUI[3];
+	uint8	type;
+	uint8	subtype;
+	uint8	data[1040];
+	struct dot11_action_wifi_vendor_specific* next_node;
+} BWL_POST_PACKED_STRUCT;
+
+typedef struct dot11_action_wifi_vendor_specific dot11_action_wifi_vendor_specific_t;
+
 #define DOT11_BA_CTL_POLICY_NORMAL	0x0000	
 #define DOT11_BA_CTL_POLICY_NOACK	0x0001	
 #define DOT11_BA_CTL_POLICY_MASK	0x0001	
@@ -160,140 +153,142 @@
 #define DOT11_BA_CTL_TID_MASK		0xF000	
 #define DOT11_BA_CTL_TID_SHIFT		12	
 
-struct dot11_ctl_header {
+BWL_PRE_PACKED_STRUCT struct dot11_ctl_header {
 	uint16			fc;		
 	uint16			durid;		
 	struct ether_addr	ra;		
 	struct ether_addr	ta;		
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 #define DOT11_CTL_HDR_LEN	16		
 
-struct dot11_bar {
+BWL_PRE_PACKED_STRUCT struct dot11_bar {
 	uint16			bar_control;	
 	uint16			seqnum;		
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 #define DOT11_BAR_LEN		4		
 
 #define DOT11_BA_BITMAP_LEN	128		
 #define DOT11_BA_CMP_BITMAP_LEN	8		
 
-struct dot11_ba {
+BWL_PRE_PACKED_STRUCT struct dot11_ba {
 	uint16			ba_control;	
 	uint16			seqnum;		
 	uint8			bitmap[DOT11_BA_BITMAP_LEN];	
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 #define DOT11_BA_LEN		4		
 
-struct dot11_management_header {
+BWL_PRE_PACKED_STRUCT struct dot11_management_header {
 	uint16			fc;		
 	uint16			durid;		
 	struct ether_addr	da;		
 	struct ether_addr	sa;		
 	struct ether_addr	bssid;		
 	uint16			seq;		
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 #define	DOT11_MGMT_HDR_LEN	24		
 
-struct dot11_bcn_prb {
+BWL_PRE_PACKED_STRUCT struct dot11_bcn_prb {
 	uint32			timestamp[2];
 	uint16			beacon_interval;
 	uint16			capability;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 #define	DOT11_BCN_PRB_LEN	12		
+#define	DOT11_BCN_PRB_FIXED_LEN	12		
 
-struct dot11_auth {
+BWL_PRE_PACKED_STRUCT struct dot11_auth {
 	uint16			alg;		
 	uint16			seq;		
 	uint16			status;		
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 #define DOT11_AUTH_FIXED_LEN	6		
 
-struct dot11_assoc_req {
+BWL_PRE_PACKED_STRUCT struct dot11_assoc_req {
 	uint16			capability;	
 	uint16			listen;		
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 #define DOT11_ASSOC_REQ_FIXED_LEN	4	
 
-struct dot11_reassoc_req {
+BWL_PRE_PACKED_STRUCT struct dot11_reassoc_req {
 	uint16			capability;	
 	uint16			listen;		
 	struct ether_addr	ap;		
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 #define DOT11_REASSOC_REQ_FIXED_LEN	10	
 
-struct dot11_assoc_resp {
+BWL_PRE_PACKED_STRUCT struct dot11_assoc_resp {
 	uint16			capability;	
 	uint16			status;		
 	uint16			aid;		
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
+#define DOT11_ASSOC_RESP_FIXED_LEN	6	
 
-struct dot11_action_measure {
+BWL_PRE_PACKED_STRUCT struct dot11_action_measure {
 	uint8	category;
 	uint8	action;
 	uint8	token;
 	uint8	data[1];
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 #define DOT11_ACTION_MEASURE_LEN	3	
 
-struct dot11_action_ht_ch_width {
+BWL_PRE_PACKED_STRUCT struct dot11_action_ht_ch_width {
 	uint8	category;
 	uint8	action;
 	uint8	ch_width;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 
-struct dot11_action_ht_mimops {
+BWL_PRE_PACKED_STRUCT struct dot11_action_ht_mimops {
 	uint8	category;
 	uint8	action;
 	uint8	control;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 
 #define SM_PWRSAVE_ENABLE	1
 #define SM_PWRSAVE_MODE		2
 
-struct dot11_power_cnst {
+BWL_PRE_PACKED_STRUCT struct dot11_power_cnst {
 	uint8 id;
 	uint8 len;
 	uint8 power;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_power_cnst dot11_power_cnst_t;
 
-struct dot11_power_cap {
+BWL_PRE_PACKED_STRUCT struct dot11_power_cap {
 	uint8 min;
 	uint8 max;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_power_cap dot11_power_cap_t;
 
-struct dot11_tpc_rep {
+BWL_PRE_PACKED_STRUCT struct dot11_tpc_rep {
 	uint8 id;
 	uint8 len;
 	uint8 tx_pwr;
 	uint8 margin;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_tpc_rep dot11_tpc_rep_t;
 #define DOT11_MNG_IE_TPC_REPORT_LEN	2 	
 
-struct dot11_supp_channels {
+BWL_PRE_PACKED_STRUCT struct dot11_supp_channels {
 	uint8 id;
 	uint8 len;
 	uint8 first_channel;
 	uint8 num_channels;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_supp_channels dot11_supp_channels_t;
 
-struct dot11_extch {
+BWL_PRE_PACKED_STRUCT struct dot11_extch {
 	uint8	id;		
 	uint8	len;		
 	uint8	extch;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_extch dot11_extch_ie_t;
 
-struct dot11_brcm_extch {
+BWL_PRE_PACKED_STRUCT struct dot11_brcm_extch {
 	uint8	id;		
 	uint8	len;		
 	uint8	oui[3];		
 	uint8	type;           
 	uint8	extch;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_brcm_extch dot11_brcm_extch_ie_t;
 
 #define BRCM_EXTCH_IE_LEN	5
@@ -304,20 +299,20 @@
 #define DOT11_EXT_CH_LOWER	0x03	
 #define DOT11_EXT_CH_NONE	0x00	
 
-struct dot11_action_frmhdr {
+BWL_PRE_PACKED_STRUCT struct dot11_action_frmhdr {
 	uint8	category;
 	uint8	action;
 	uint8	data[1];
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 #define DOT11_ACTION_FRMHDR_LEN	2
 
-struct dot11_channel_switch {
+BWL_PRE_PACKED_STRUCT struct dot11_channel_switch {
 	uint8 id;	
 	uint8 len;	
 	uint8 mode;	
 	uint8 channel;	
 	uint8 count;	
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_channel_switch dot11_chan_switch_ie_t;
 
 #define DOT11_SWITCH_IE_LEN	3	
@@ -325,35 +320,45 @@
 #define DOT11_CSA_MODE_ADVISORY		0	
 #define DOT11_CSA_MODE_NO_TX		1	
 
-struct dot11_action_switch_channel {
+BWL_PRE_PACKED_STRUCT struct dot11_action_switch_channel {
 	uint8	category;
 	uint8	action;
 	dot11_chan_switch_ie_t chan_switch_ie;	
 	dot11_brcm_extch_ie_t extch_ie;		
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 
-struct dot11_ext_csa {
-	uint8 id;	
-	uint8 len;	
+BWL_PRE_PACKED_STRUCT struct dot11_csa_body {
 	uint8 mode;	
 	uint8 reg;	
 	uint8 channel;	
 	uint8 count;	
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
+
+BWL_PRE_PACKED_STRUCT struct dot11_ext_csa {
+	uint8 id;	
+	uint8 len;	
+	struct dot11_csa_body b;	
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_ext_csa dot11_ext_csa_ie_t;
 #define DOT11_EXT_CSA_IE_LEN	4	
 
-struct dot11_action_ext_csa {
+BWL_PRE_PACKED_STRUCT struct dot11_action_ext_csa {
 	uint8	category;
 	uint8	action;
 	dot11_ext_csa_ie_t chan_switch_ie;	
-} PACKED;
-
-struct dot11_obss_coex {
+} BWL_POST_PACKED_STRUCT;
+
+BWL_PRE_PACKED_STRUCT struct dot11y_action_ext_csa {
+	uint8	category;
+	uint8	action;
+	struct dot11_csa_body b;	
+} BWL_POST_PACKED_STRUCT;
+
+BWL_PRE_PACKED_STRUCT struct dot11_obss_coex {
 	uint8	id;
 	uint8	len;
 	uint8	info;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_obss_coex dot11_obss_coex_t;
 #define DOT11_OBSS_COEXINFO_LEN	1	
 
@@ -361,30 +366,40 @@
 #define	DOT11_OBSS_COEX_40MHZ_INTOLERANT	0x02
 #define	DOT11_OBSS_COEX_20MHZ_WIDTH_REQ	0x04
 
-struct dot11_obss_chanlist {
+BWL_PRE_PACKED_STRUCT struct dot11_obss_chanlist {
 	uint8	id;
 	uint8	len;
 	uint8	regclass;
 	uint8	chanlist[1];
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_obss_chanlist dot11_obss_chanlist_t;
 #define DOT11_OBSS_CHANLIST_FIXED_LEN	1	
 
-struct dot11_extcap_ie {
+BWL_PRE_PACKED_STRUCT struct dot11_extcap_ie {
 	uint8 id;
 	uint8 len;
 	uint8 cap;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_extcap_ie dot11_extcap_ie_t;
 #define DOT11_EXTCAP_LEN	1
 
 #define DOT11_MEASURE_TYPE_BASIC 	0	
 #define DOT11_MEASURE_TYPE_CCA 		1	
 #define DOT11_MEASURE_TYPE_RPI		2	
+#define DOT11_MEASURE_TYPE_CHLOAD		3	
+#define DOT11_MEASURE_TYPE_NOISE		4	
+#define DOT11_MEASURE_TYPE_BEACON		5	
+#define DOT11_MEASURE_TYPE_FRAME	6	
+#define DOT11_MEASURE_TYPE_STATS		7	
+#define DOT11_MEASURE_TYPE_LCI		8	
+#define DOT11_MEASURE_TYPE_TXSTREAM		9	
+#define DOT11_MEASURE_TYPE_PAUSE		255	
 
+#define DOT11_MEASURE_MODE_PARALLEL 	(1<<0)	
 #define DOT11_MEASURE_MODE_ENABLE 	(1<<1)	
 #define DOT11_MEASURE_MODE_REQUEST	(1<<2)	
 #define DOT11_MEASURE_MODE_REPORT 	(1<<3)	
+#define DOT11_MEASURE_MODE_DUR 	(1<<4)	
 
 #define DOT11_MEASURE_MODE_LATE 	(1<<0)	
 #define DOT11_MEASURE_MODE_INCAPABLE	(1<<1)	
@@ -396,7 +411,7 @@
 #define DOT11_MEASURE_BASIC_MAP_RADAR	((uint8)(1<<3))	
 #define DOT11_MEASURE_BASIC_MAP_UNMEAS	((uint8)(1<<4))	
 
-struct dot11_meas_req {
+BWL_PRE_PACKED_STRUCT struct dot11_meas_req {
 	uint8 id;
 	uint8 len;
 	uint8 token;
@@ -405,65 +420,65 @@
 	uint8 channel;
 	uint8 start_time[8];
 	uint16 duration;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_meas_req dot11_meas_req_t;
 #define DOT11_MNG_IE_MREQ_LEN 14	
 
 #define DOT11_MNG_IE_MREQ_FIXED_LEN 3	
 
-struct dot11_meas_rep {
+BWL_PRE_PACKED_STRUCT struct dot11_meas_rep {
 	uint8 id;
 	uint8 len;
 	uint8 token;
 	uint8 mode;
 	uint8 type;
-	union
+	BWL_PRE_PACKED_STRUCT union
 	{
-		struct {
+		BWL_PRE_PACKED_STRUCT struct {
 			uint8 channel;
 			uint8 start_time[8];
 			uint16 duration;
 			uint8 map;
-		} PACKED basic;
+		} BWL_POST_PACKED_STRUCT basic;
 		uint8 data[1];
-	} PACKED rep;
-} PACKED;
+	} BWL_POST_PACKED_STRUCT rep;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_meas_rep dot11_meas_rep_t;
 
 #define DOT11_MNG_IE_MREP_FIXED_LEN	3	
 
-struct dot11_meas_rep_basic {
+BWL_PRE_PACKED_STRUCT struct dot11_meas_rep_basic {
 	uint8 channel;
 	uint8 start_time[8];
 	uint16 duration;
 	uint8 map;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_meas_rep_basic dot11_meas_rep_basic_t;
 #define DOT11_MEASURE_BASIC_REP_LEN	12	
 
-struct dot11_quiet {
+BWL_PRE_PACKED_STRUCT struct dot11_quiet {
 	uint8 id;
 	uint8 len;
 	uint8 count;	
 	uint8 period;	
 	uint16 duration;	
 	uint16 offset;	
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_quiet dot11_quiet_t;
 
-struct chan_map_tuple {
+BWL_PRE_PACKED_STRUCT struct chan_map_tuple {
 	uint8 channel;
 	uint8 map;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct chan_map_tuple chan_map_tuple_t;
 
-struct dot11_ibss_dfs {
+BWL_PRE_PACKED_STRUCT struct dot11_ibss_dfs {
 	uint8 id;
 	uint8 len;
 	uint8 eaddr[ETHER_ADDR_LEN];
 	uint8 interval;
 	chan_map_tuple_t map[1];
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_ibss_dfs dot11_ibss_dfs_t;
 
 #define WME_OUI			"\x00\x50\xf2"	
@@ -487,24 +502,24 @@
 #define AC_BITMAP_SET(ab, ac)	(((ab) |= (1 << (ac))))
 #define AC_BITMAP_RESET(ab, ac) (((ab) &= ~(1 << (ac))))
 
-struct wme_ie {
+BWL_PRE_PACKED_STRUCT struct wme_ie {
 	uint8 oui[3];
 	uint8 type;
 	uint8 subtype;
 	uint8 version;
 	uint8 qosinfo;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct wme_ie wme_ie_t;
 #define WME_IE_LEN 7	
 
-struct edcf_acparam {
+BWL_PRE_PACKED_STRUCT struct edcf_acparam {
 	uint8	ACI;
 	uint8	ECW;
 	uint16  TXOP;		
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct edcf_acparam edcf_acparam_t;
 
-struct wme_param_ie {
+BWL_PRE_PACKED_STRUCT struct wme_param_ie {
 	uint8 oui[3];
 	uint8 type;
 	uint8 subtype;
@@ -512,7 +527,7 @@
 	uint8 qosinfo;
 	uint8 rsvd;
 	edcf_acparam_t acparam[AC_COUNT];
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct wme_param_ie wme_param_ie_t;
 #define WME_PARAM_IE_LEN            24          
 
@@ -553,6 +568,8 @@
 #define EDCF_TXOP_MAX                65535       
 #define EDCF_TXOP2USEC(txop)         ((txop) << 5)
 
+#define NON_EDCF_AC_BE_ACI_STA          0x02
+
 #define EDCF_AC_BE_ACI_STA           0x03	
 #define EDCF_AC_BE_ECW_STA           0xA4	
 #define EDCF_AC_BE_TXOP_STA          0x0000	
@@ -566,8 +583,6 @@
 #define EDCF_AC_VO_ECW_STA           0x32	
 #define EDCF_AC_VO_TXOP_STA          0x002f	
 
-#define NON_EDCF_AC_BE_ACI_STA		0x02
-
 #define EDCF_AC_BE_ACI_AP            0x03	
 #define EDCF_AC_BE_ECW_AP            0x64	
 #define EDCF_AC_BE_TXOP_AP           0x0000	
@@ -581,13 +596,26 @@
 #define EDCF_AC_VO_ECW_AP            0x32	
 #define EDCF_AC_VO_TXOP_AP           0x002f	
 
-struct dot11_qbss_load_ie {
+BWL_PRE_PACKED_STRUCT struct edca_param_ie {
+	uint8 qosinfo;
+	uint8 rsvd;
+	edcf_acparam_t acparam[AC_COUNT];
+} BWL_POST_PACKED_STRUCT;
+typedef struct edca_param_ie edca_param_ie_t;
+#define EDCA_PARAM_IE_LEN            18          
+
+BWL_PRE_PACKED_STRUCT struct qos_cap_ie {
+	uint8 qosinfo;
+} BWL_POST_PACKED_STRUCT;
+typedef struct qos_cap_ie qos_cap_ie_t;
+
+BWL_PRE_PACKED_STRUCT struct dot11_qbss_load_ie {
 	uint8 id; 			
 	uint8 length;
 	uint16 station_count; 		
 	uint8 channel_utilization;	
 	uint16 aac; 			
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_qbss_load_ie dot11_qbss_load_ie_t;
 
 #define FIXED_MSDU_SIZE 0x8000		
@@ -596,13 +624,13 @@
 #define	INTEGER_SHIFT	13	
 #define FRACTION_MASK	0x1FFF	
 
-struct dot11_management_notification {
+BWL_PRE_PACKED_STRUCT struct dot11_management_notification {
 	uint8 category;			
 	uint8 action;
 	uint8 token;
 	uint8 status;
 	uint8 data[1];			
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 #define DOT11_MGMT_NOTIFICATION_LEN 4	
 
 #define WME_ADDTS_REQUEST	0	
@@ -841,6 +869,7 @@
 #define DOT11_MNG_HOPPING_TABLE_ID		9	
 #define DOT11_MNG_REQUEST_ID			10	
 #define DOT11_MNG_QBSS_LOAD_ID 			11	
+#define DOT11_MNG_EDCA_PARAM_ID			12	
 #define DOT11_MNG_CHALLENGE_ID			16	
 #define DOT11_MNG_PWR_CONSTRAINT_ID		32	
 #define DOT11_MNG_PWR_CAP_ID			33	
@@ -855,13 +884,22 @@
 #define DOT11_MNG_ERP_ID			42	
 #define DOT11_MNG_TS_DELAY_ID			43	
 #define	DOT11_MNG_HT_CAP			45	
+#define DOT11_MNG_QOS_CAP_ID			46	
 #define DOT11_MNG_NONERP_ID			47	
 #define DOT11_MNG_RSN_ID			48	
 #define DOT11_MNG_EXT_RATES_ID			50	
+#define DOT11_MNG_AP_CHREP_ID		51	
+#define DOT11_MNG_NBR_REP_ID		52	
 #define	DOT11_MNG_REGCLASS_ID			59	
 #define DOT11_MNG_EXT_CSA_ID			60	
 #define	DOT11_MNG_HT_ADD			61	
 #define	DOT11_MNG_EXT_CHANNEL_OFFSET		62	
+
+#ifdef BCMWAPI_WAI
+#define DOT11_MNG_WAPI_ID			68	
+#endif
+
+#define DOT11_MNG_RRM_CAP_ID		70	
 #define	DOT11_MNG_HT_BSS_COEXINFO_ID		72	
 #define	DOT11_MNG_HT_BSS_CHANNEL_REPORT_ID	73	
 #define	DOT11_MNG_HT_OBSS_ID			74	
@@ -890,30 +928,37 @@
 #define DOT11_CAP_AGILITY			0x0080	
 #define DOT11_CAP_SPECTRUM			0x0100	
 #define DOT11_CAP_SHORTSLOT			0x0400	
+#define DOT11_CAP_RM			0x1000	
 #define DOT11_CAP_CCK_OFDM			0x2000	
 
 #define DOT11_OBSS_COEX_MNG_SUPPORT	0x01	
 
 #define DOT11_ACTION_HDR_LEN		2	
+
 #define DOT11_ACTION_CAT_ERR_MASK	0x80	
 #define DOT11_ACTION_CAT_MASK		0x7F	
 #define DOT11_ACTION_CAT_SPECT_MNG	0	
+#define DOT11_ACTION_CAT_QOS		1	
+#define DOT11_ACTION_CAT_DLS		2	
 #define DOT11_ACTION_CAT_BLOCKACK	3	
 #define DOT11_ACTION_CAT_PUBLIC		4	
+#define DOT11_ACTION_CAT_RM		5	
 #define DOT11_ACTION_CAT_HT		7	
+#define DOT11_ACTION_CAT_VS		127	
 #define DOT11_ACTION_NOTIFICATION	0x11	
 
-#define DOT11_ACTION_ID_M_REQ		0	
-#define DOT11_ACTION_ID_M_REP		1	
-#define DOT11_ACTION_ID_TPC_REQ		2	
-#define DOT11_ACTION_ID_TPC_REP		3	
-#define DOT11_ACTION_ID_CHANNEL_SWITCH	4	
-#define DOT11_ACTION_ID_EXT_CSA		5	
+#define DOT11_SM_ACTION_M_REQ		0	
+#define DOT11_SM_ACTION_M_REP		1	
+#define DOT11_SM_ACTION_TPC_REQ		2	
+#define DOT11_SM_ACTION_TPC_REP		3	
+#define DOT11_SM_ACTION_CHANNEL_SWITCH	4	
+#define DOT11_SM_ACTION_EXT_CSA		5	
 
 #define DOT11_ACTION_ID_HT_CH_WIDTH	0	
 #define DOT11_ACTION_ID_HT_MIMO_PS	1	
 
-#define DOT11_ACTION_ID_BSS_COEX_MNG	0	
+#define DOT11_PUB_ACTION_BSS_COEX_MNG	0	
+#define DOT11_PUB_ACTION_CHANNEL_SWITCH	4	
 
 #define DOT11_BA_ACTION_ADDBA_REQ	0	
 #define DOT11_BA_ACTION_ADDBA_RESP	1	
@@ -930,25 +975,25 @@
 #define DOT11_ADDBA_POLICY_DELAYED	0	
 #define DOT11_ADDBA_POLICY_IMMEDIATE	1	
 
-struct dot11_addba_req {
+BWL_PRE_PACKED_STRUCT struct dot11_addba_req {
 	uint8 category;				
 	uint8 action;				
 	uint8 token;				
 	uint16 addba_param_set;			
 	uint16 timeout;				
 	uint16 start_seqnum;			
-}PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_addba_req dot11_addba_req_t;
 #define DOT11_ADDBA_REQ_LEN		9	
 
-struct dot11_addba_resp {
+BWL_PRE_PACKED_STRUCT struct dot11_addba_resp {
 	uint8 category;				
 	uint8 action;				
 	uint8 token;				
 	uint16 status;				
 	uint16 addba_param_set;			
 	uint16 timeout;				
-}PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_addba_resp dot11_addba_resp_t;
 #define DOT11_ADDBA_RESP_LEN		9	
 
@@ -957,15 +1002,118 @@
 #define DOT11_DELBA_PARAM_TID_MASK	0xf000	
 #define DOT11_DELBA_PARAM_TID_SHIFT	12	
 
-struct dot11_delba {
+BWL_PRE_PACKED_STRUCT struct dot11_delba {
 	uint8 category;				
 	uint8 action;				
 	uint16 delba_param_set;			
 	uint16 reason;				
-}PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_delba dot11_delba_t;
 #define DOT11_DELBA_LEN			6	
 
+#define DOT11_RRM_CAP_LEN		5	
+BWL_PRE_PACKED_STRUCT struct dot11_rrm_cap_ie {
+	uint8 cap[DOT11_RRM_CAP_LEN];
+} BWL_POST_PACKED_STRUCT;
+typedef struct dot11_rrm_cap_ie dot11_rrm_cap_ie_t;
+
+#define DOT11_RRM_CAP_LINK			0
+#define DOT11_RRM_CAP_NEIGHBOR_REPORT	1
+#define DOT11_RRM_CAP_PARALLEL		2
+#define DOT11_RRM_CAP_REPEATED		3
+#define DOT11_RRM_CAP_BCN_PASSIVE	4
+#define DOT11_RRM_CAP_BCN_ACTIVE	5
+#define DOT11_RRM_CAP_BCN_TABLE		6
+#define DOT11_RRM_CAP_BCN_REP_COND	7
+
+#define DOT11_RM_ACTION_RM_REQ		0	
+#define DOT11_RM_ACTION_RM_REP		1	
+#define DOT11_RM_ACTION_LM_REQ		2	
+#define DOT11_RM_ACTION_LM_REP		3	
+#define DOT11_RM_ACTION_NR_REQ		4	
+#define DOT11_RM_ACTION_NR_REP		5	
+
+BWL_PRE_PACKED_STRUCT struct dot11_rm_action {
+	uint8 category;				
+	uint8 action;				
+	uint8 token;				
+	uint8 data[1];
+} BWL_POST_PACKED_STRUCT;
+typedef struct dot11_rm_action dot11_rm_action_t;
+#define DOT11_RM_ACTION_LEN 3
+
+BWL_PRE_PACKED_STRUCT struct dot11_rmreq {
+	uint8 category;				
+	uint8 action;				
+	uint8 token;				
+	uint16 reps;				
+} BWL_POST_PACKED_STRUCT;
+typedef struct dot11_rmreq dot11_rmreq_t;
+#define DOT11_RMREQ_LEN	5
+
+BWL_PRE_PACKED_STRUCT struct dot11_rm_ie {
+	uint8 id;
+	uint8 len;
+	uint8 token;
+	uint8 mode;
+	uint8 type;
+} BWL_POST_PACKED_STRUCT;
+typedef struct dot11_rm_ie dot11_rm_ie_t;
+#define DOT11_RM_IE_LEN	5
+
+BWL_PRE_PACKED_STRUCT struct dot11_rmreq_bcn {
+	uint8 id;
+	uint8 len;
+	uint8 token;
+	uint8 mode;
+	uint8 type;
+	uint8 reg;
+	uint8 channel;
+	uint16 interval;
+	uint16 duration;
+	uint8 bcn_mode;
+	struct ether_addr	bssid;
+} BWL_POST_PACKED_STRUCT;
+typedef struct dot11_rmreq_bcn dot11_rmreq_bcn_t;
+#define DOT11_RMREQ_BCN_LEN	18
+
+BWL_PRE_PACKED_STRUCT struct dot11_rmrep_bcn {
+	uint8 reg;
+	uint8 channel;
+	uint32 starttime[2];
+	uint16 duration;
+	uint8 frame_info;
+	uint8 rcpi;
+	uint8 rsni;
+	struct ether_addr	bssid;
+	uint8 antenna_id;
+	uint32 parent_tsf;
+} BWL_POST_PACKED_STRUCT;
+typedef struct dot11_rmrep_bcn dot11_rmrep_bcn_t;
+#define DOT11_RMREP_BCN_LEN	26
+
+#define DOT11_RMREQ_BCN_PASSIVE	0
+#define DOT11_RMREQ_BCN_ACTIVE	1
+#define DOT11_RMREQ_BCN_BCNTABLE	2
+
+#define DOT11_RMREQ_BCN_SSID_ID	0
+#define DOT11_RMREQ_BCN_REPINFO_ID	1
+#define DOT11_RMREQ_BCN_REPDET_ID	2
+#define DOT11_RMREQ_BCN_REQUEST_ID	10
+#define DOT11_RMREQ_BCN_APCHREP_ID	51
+
+#define DOT11_RMREP_BCN_FRM_BODY	1
+
+BWL_PRE_PACKED_STRUCT struct dot11_rmrep_nbr {
+	struct ether_addr	bssid;
+	uint32	bssid_info;
+	uint8 reg;
+	uint8 channel;
+	uint8 phytype;
+} BWL_POST_PACKED_STRUCT;
+typedef struct dot11_rmrep_nbr dot11_rmrep_nbr_t;
+#define DOT11_RMREP_NBR_LEN	13
+
 #define DOT11_BSSTYPE_INFRASTRUCTURE		0	
 #define DOT11_BSSTYPE_INDEPENDENT		1	
 #define DOT11_BSSTYPE_ANY			2	
@@ -973,10 +1121,10 @@
 #define DOT11_SCANTYPE_PASSIVE			1	
 
 #define PREN_PREAMBLE		24	
-#define PREN_MM_EXT		8	
+#define PREN_MM_EXT		12	
 #define PREN_PREAMBLE_EXT	4	
 
-#define NPHY_RIFS_TIME		2	
+#define RIFS_11N_TIME		2	
 
 #define APHY_SLOT_TIME		9	
 #define APHY_SIFS_TIME		16	
@@ -1022,7 +1170,7 @@
 
 #define BRCM_OUI		"\x00\x10\x18"	
 
-struct brcm_ie {
+BWL_PRE_PACKED_STRUCT struct brcm_ie {
 	uint8	id;		
 	uint8	len;		
 	uint8	oui[3];		
@@ -1031,7 +1179,7 @@
 	uint8	flags;		
 	uint8	flags1;		
 	uint16	amsdu_mtu_pref;	
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef	struct brcm_ie brcm_ie_t;
 #define BRCM_IE_LEN		11	
 #define BRCM_IE_VER		2	
@@ -1047,26 +1195,38 @@
 
 #define AB_GUARDCOUNT	10		
 
+BWL_PRE_PACKED_STRUCT struct vndr_ie {
+	uchar id;
+	uchar len;
+	uchar oui [3];
+	uchar data [1]; 	
+} BWL_POST_PACKED_STRUCT;
+typedef struct vndr_ie vndr_ie_t;
+
+#define VNDR_IE_HDR_LEN		2	
+#define VNDR_IE_MIN_LEN		3	
+#define VNDR_IE_MAX_LEN		256	
+
 #define MCSSET_LEN	16	
 #define MAX_MCS_NUM	(128)	
 
-struct ht_cap_ie {
+BWL_PRE_PACKED_STRUCT struct ht_cap_ie {
 	uint16	cap;
 	uint8	params;
 	uint8	supp_mcs[MCSSET_LEN];
 	uint16	ext_htcap;
 	uint32	txbf_cap;
 	uint8	as_cap;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct ht_cap_ie ht_cap_ie_t;
 
-struct ht_prop_cap_ie {
+BWL_PRE_PACKED_STRUCT struct ht_prop_cap_ie {
 	uint8	id;		
 	uint8	len;		
 	uint8	oui[3];		
 	uint8	type;           
 	ht_cap_ie_t cap_ie;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct ht_prop_cap_ie ht_prop_cap_ie_t;
 
 #define HT_PROP_IE_OVERHEAD	4	
@@ -1088,7 +1248,7 @@
 #define HT_CAP_RX_STBC_SHIFT	8	
 #define HT_CAP_DELAYED_BA	0x0400	
 #define HT_CAP_MAX_AMSDU	0x0800	
-#define HT_CAP_DSSS_CCK		0x1000	
+#define HT_CAP_DSSS_CCK	0x1000	
 #define HT_CAP_PSMP		0x2000	
 #define HT_CAP_40MHZ_INTOLERANT 0x4000	
 #define HT_CAP_LSIG_TXOP	0x8000	
@@ -1103,7 +1263,7 @@
 
 #define HT_PARAMS_RX_FACTOR_MASK	0x03	
 #define HT_PARAMS_DENSITY_MASK		0x1C	
-#define HT_PARAMS_DENSITY_SHIFT		2	
+#define HT_PARAMS_DENSITY_SHIFT	2	
 
 #define AMPDU_MAX_MPDU_DENSITY	7	
 #define AMPDU_RX_FACTOR_8K	0	
@@ -1114,22 +1274,22 @@
 
 #define AMPDU_DELIMITER_LEN	4	
 
-struct ht_add_ie {
+BWL_PRE_PACKED_STRUCT struct ht_add_ie {
 	uint8	ctl_ch;			
 	uint8	byte1;			
 	uint16	opmode;			
 	uint16	misc_bits;		
 	uint8	basic_mcs[MCSSET_LEN];  
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct ht_add_ie ht_add_ie_t;
 
-struct ht_prop_add_ie {
+BWL_PRE_PACKED_STRUCT struct ht_prop_add_ie {
 	uint8	id;		
 	uint8	len;		
 	uint8	oui[3];		
 	uint8	type;		
 	ht_add_ie_t add_ie;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct ht_prop_add_ie ht_prop_add_ie_t;
 
 #define HT_ADD_IE_LEN	22
@@ -1139,7 +1299,7 @@
 #define HT_RIFS_PERMITTED     	0x08	
 
 #define HT_OPMODE_MASK	        0x0003	
-#define HT_OPMODE_SHIFT	0	
+#define HT_OPMODE_SHIFT		0	
 #define HT_OPMODE_PURE		0x0000	
 #define HT_OPMODE_OPTIONAL	0x0001	
 #define HT_OPMODE_HT20IN40	0x0002	
@@ -1175,7 +1335,7 @@
 #define DOT11N_OBSS_NONHT_PRESENT(add_ie)	((ltoh16_ua(&add_ie->opmode) & DOT11N_OBSS_NONHT) \
 					== DOT11N_OBSS_NONHT)	
 
-struct obss_params {
+BWL_PRE_PACKED_STRUCT struct obss_params {
 	uint16	passive_dwell;
 	uint16	active_dwell;
 	uint16	bss_widthscan_interval;
@@ -1183,28 +1343,46 @@
 	uint16	active_total;
 	uint16	chanwidth_transition_dly;
 	uint16	activity_threshold;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct obss_params obss_params_t;
 
-struct dot11_obss_ie {
+BWL_PRE_PACKED_STRUCT struct dot11_obss_ie {
 	uint8	id;
 	uint8	len;
 	obss_params_t obss_params;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 typedef struct dot11_obss_ie dot11_obss_ie_t;
 #define DOT11_OBSS_SCAN_IE_LEN	sizeof(obss_params_t)	
 
-struct vndr_ie {
-	uchar id;
-	uchar len;
-	uchar oui [3];
-	uchar data [1]; 	
-} PACKED;
-typedef struct vndr_ie vndr_ie_t;
+#define HT_CTRL_LA_TRQ		0x00000002	
+#define HT_CTRL_LA_MAI		0x0000003C	
+#define HT_CTRL_LA_MAI_SHIFT	2
+#define HT_CTRL_LA_MAI_MRQ	0x00000004	
+#define HT_CTRL_LA_MAI_MSI	0x00000038	
+#define HT_CTRL_LA_MFSI		0x000001C0	
+#define HT_CTRL_LA_MFSI_SHIFT	6
+#define HT_CTRL_LA_MFB_ASELC	0x0000FE00	
+#define HT_CTRL_LA_MFB_ASELC_SH	9
+#define HT_CTRL_LA_ASELC_CMD	0x00000C00	
+#define HT_CTRL_LA_ASELC_DATA	0x0000F000	
+#define HT_CTRL_CAL_POS		0x00030000	
+#define HT_CTRL_CAL_SEQ		0x000C0000	
+#define HT_CTRL_CSI_STEERING	0x00C00000	
+#define HT_CTRL_CSI_STEER_SHIFT	22
+#define HT_CTRL_CSI_STEER_NFB	0		
+#define HT_CTRL_CSI_STEER_CSI	1		
+#define HT_CTRL_CSI_STEER_NCOM	2		
+#define HT_CTRL_CSI_STEER_COM	3		
+#define HT_CTRL_NDP_ANNOUNCE	0x01000000	
+#define HT_CTRL_AC_CONSTRAINT	0x40000000	
+#define HT_CTRL_RDG_MOREPPDU	0x80000000	
 
-#define VNDR_IE_HDR_LEN		2	
-#define VNDR_IE_MIN_LEN		3	
-#define VNDR_IE_MAX_LEN		256	
+#define HT_OPMODE_OPTIONAL	0x0001	
+#define HT_OPMODE_HT20IN40	0x0002	
+#define HT_OPMODE_MIXED	0x0003	
+#define HT_OPMODE_NONGF	0x0004	
+#define DOT11N_TXBURST		0x0008	
+#define DOT11N_OBSS_NONHT	0x0010	
 
 #define WPA_VERSION		1	
 #define WPA_OUI			"\x00\x50\xF2"	
@@ -1223,7 +1401,7 @@
 #define DOT11_MAX_KEY_SIZE	32	
 #define DOT11_MAX_IV_SIZE	16	
 #define DOT11_EXT_IV_FLAG	(1<<5)	
-#define DOT11_WPA_KEY_RSC_LEN	8	
+#define DOT11_WPA_KEY_RSC_LEN   8       
 
 #define WEP1_KEY_SIZE		5	
 #define WEP1_KEY_HEX_SIZE	10	
@@ -1240,9 +1418,17 @@
 #define AES_KEY_SIZE		16	
 #define AES_MIC_SIZE		8	
 
-#undef PACKED
-#if !defined(__GNUC__)
-#pragma pack()
-#endif
+#define WCN_OUI			"\x00\x50\xf2"	
+#define WCN_TYPE		4	
+
+#ifdef BCMWAPI_WAI
+#define WAPI_IE_MIN_LEN 	20	
+#define WAPI_VERSION		1	
+#define WAPI_VERSION_LEN	2	
+#define WAPI_OUI		"\x00\x14\x72"	
+#define WAPI_OUI_LEN		DOT11_OUI_LEN	
+#endif 
+
+#include <packed_section_end.h>
 
 #endif 

=== modified file 'src/src/include/proto/802.1d.h'
--- src/src/include/proto/802.1d.h	2009-05-11 16:04:29 +0000
+++ src/src/include/proto/802.1d.h	2010-02-14 19:58:58 +0000
@@ -1,20 +1,7 @@
 /*
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS

=== modified file 'src/src/include/proto/bcmeth.h'
--- src/src/include/proto/bcmeth.h	2009-05-11 16:04:29 +0000
+++ src/src/include/proto/bcmeth.h	2010-02-14 19:58:58 +0000
@@ -1,41 +1,27 @@
 /*
  * Broadcom Ethernettype  protocol definitions
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: bcmeth.h,v 9.9.12.2 2008/05/02 23:24:25 Exp $
+ * $Id: bcmeth.h,v 9.11.68.1 2009/11/04 02:12:59 Exp $
  */
 
 #ifndef _BCMETH_H_
 #define _BCMETH_H_
 
-#if defined(__GNUC__)
-#define	PACKED	__attribute__((packed))
-#else
-#pragma pack(1)
-#define	PACKED
+#ifndef _TYPEDEFS_H_
+#include <typedefs.h>
 #endif
 
-typedef  struct bcmeth_hdr
+#include <packed_section_start.h>
+
+typedef BWL_PRE_PACKED_STRUCT struct bcmeth_hdr
 {
 	uint16	subtype;	
 	uint16	length;
@@ -43,11 +29,8 @@
 	uint8	oui[3];		
 
 	uint16	usr_subtype;
-} PACKED bcmeth_hdr_t;
+} BWL_POST_PACKED_STRUCT bcmeth_hdr_t;
 
-#undef PACKED
-#if !defined(__GNUC__)
-#pragma pack()
-#endif
+#include <packed_section_end.h>
 
 #endif	

=== modified file 'src/src/include/proto/bcmevent.h'
--- src/src/include/proto/bcmevent.h	2009-05-11 16:04:29 +0000
+++ src/src/include/proto/bcmevent.h	2010-02-14 19:58:58 +0000
@@ -1,22 +1,9 @@
 /*
  * Broadcom Event  protocol definitions
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
@@ -24,19 +11,18 @@
  *
  * Dependencies: proto/bcmeth.h
  *
- * $Id: bcmevent.h,v 9.35.2.5 2009/03/04 00:30:40 Exp $
+ * $Id: bcmevent.h,v 9.52.2.5 2009/10/22 07:38:44 Exp $
  *
  */
 
 #ifndef _BCMEVENT_H_
 #define _BCMEVENT_H_
 
-#if defined(__GNUC__)
-#define	PACKED	__attribute__((packed))
-#else
-#pragma pack(1)
-#define	PACKED
-#endif 
+#ifndef _TYPEDEFS_H_
+#include <typedefs.h>
+#endif
+
+#include <packed_section_start.h>
 
 #define BCM_EVENT_MSG_VERSION		1	
 #define BCM_MSG_IFNAME_MAX		16	
@@ -45,7 +31,7 @@
 #define WLC_EVENT_MSG_FLUSHTXQ		0x02	
 #define WLC_EVENT_MSG_GROUP		0x04	
 
-typedef struct
+typedef BWL_PRE_PACKED_STRUCT struct
 {
 	uint16	version;
 	uint16	flags;			
@@ -56,14 +42,14 @@
 	uint32	datalen;		
 	struct ether_addr	addr;	
 	char	ifname[BCM_MSG_IFNAME_MAX]; 
-} PACKED wl_event_msg_t;
+} BWL_POST_PACKED_STRUCT wl_event_msg_t;
 
-typedef struct bcm_event {
+typedef BWL_PRE_PACKED_STRUCT struct bcm_event {
 	struct ether_header eth;
 	bcmeth_hdr_t		bcm_hdr;
 	wl_event_msg_t		event;
 
-} PACKED bcm_event_t;
+} BWL_POST_PACKED_STRUCT bcm_event_t;
 
 #define BCM_MSG_LEN	(sizeof(bcm_event_t) - sizeof(bcmeth_hdr_t) - sizeof(struct ether_header))
 
@@ -111,14 +97,28 @@
 #define WLC_E_PSM_WATCHDOG	41	
 #define WLC_E_PROBREQ_MSG       44      
 #define WLC_E_SCAN_CONFIRM_IND  45
-#define WLC_E_PSK_SUP	46	
+#define WLC_E_PSK_SUP		46	
 #define WLC_E_COUNTRY_CODE_CHANGED 47
 #define	WLC_E_EXCEEDED_MEDIUM_TIME 48	
 #define WLC_E_ICV_ERROR		49	
-#define WLC_E_UNICAST_DECODE_ERROR 50 
+#define WLC_E_UNICAST_DECODE_ERROR 50	
 #define WLC_E_MULTICAST_DECODE_ERROR 51 
-#define WLC_E_EXTLOG_MSG	52
-#define WLC_E_LAST			53	
+#define WLC_E_TRACE		52
+#define WLC_E_IF		54	
+#define WLC_E_RSSI		56	
+#define WLC_E_PFN_SCAN_COMPLETE	57	
+#define WLC_E_EXTLOG_MSG	58
+#define WLC_E_ACTION_FRAME      59 
+#define WLC_E_ACTION_FRAME_COMPLETE      60 
+#define WLC_E_PRE_ASSOC_IND	61	
+#define WLC_E_PRE_REASSOC_IND	62	
+#define WLC_E_CHANNEL_ADOPTED	63	
+#define WLC_E_AP_STARTED	64	
+#define WLC_E_DFS_AP_STOP	65	
+#define WLC_E_DFS_AP_RESUME	66	
+#define WLC_E_WAI_STA_EVENT	67	
+#define WLC_E_WAI_MSG 		68	
+#define WLC_E_LAST		69	
 
 #define WLC_E_STATUS_SUCCESS		0	
 #define WLC_E_STATUS_FAIL		1	
@@ -134,6 +134,7 @@
 #define WLC_E_STATUS_11HQUIET	11	
 #define WLC_E_STATUS_SUPPRESS	12	
 #define WLC_E_STATUS_NOCHANS	13	
+#define WLC_E_STATUS_CS_ABORT	15	
 
 #define WLC_E_REASON_INITIAL_ASSOC	0	
 #define WLC_E_REASON_LOW_RSSI		1	
@@ -164,7 +165,7 @@
 #define WLC_E_PRUNE_QBSS_LOAD		16	
 #define WLC_E_PRUNE_HOME_AP		17	
 
-#define WLC_E_SUP_OTHER				0	
+#define WLC_E_SUP_OTHER			0	
 #define WLC_E_SUP_DECRYPT_KEY_DATA	1	
 #define WLC_E_SUP_BAD_UCAST_WEP128	2	
 #define WLC_E_SUP_BAD_UCAST_WEP40	3	
@@ -177,17 +178,17 @@
 #define WLC_E_SUP_GRP_KEY_CIPHER	10	
 #define WLC_E_SUP_GRP_MSG1_NO_GTK	11	
 #define WLC_E_SUP_GTK_DECRYPT_FAIL	12	
-#define WLC_E_SUP_SEND_FAIL			13	
-#define WLC_E_SUP_DEAUTH			14	
+#define WLC_E_SUP_SEND_FAIL		13	
+#define WLC_E_SUP_DEAUTH		14	
+
+#define WLC_E_IF_ADD		1	
+#define WLC_E_IF_DEL		2	
 
 #define WLC_E_LINK_BCN_LOSS	1	
 #define WLC_E_LINK_DISASSOC	2	
 #define WLC_E_LINK_ASSOC_REC	3	
 #define WLC_E_LINK_BSSCFG_DIS	4	
 
-#undef PACKED
-#if !defined(__GNUC__)
-#pragma pack()
-#endif 
+#include <packed_section_end.h>
 
 #endif 

=== modified file 'src/src/include/proto/ethernet.h'
--- src/src/include/proto/ethernet.h	2009-05-11 16:04:29 +0000
+++ src/src/include/proto/ethernet.h	2010-02-14 19:58:58 +0000
@@ -1,28 +1,15 @@
 /*
  * From FreeBSD 2.2.7: Fundamental constants relating to ethernet.
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: ethernet.h,v 9.45.12.1 2008/08/13 02:24:19 Exp $
+ * $Id: ethernet.h,v 9.50.4.3 2009/10/22 07:38:44 Exp $
  */
 
 #ifndef _NET_ETHERNET_H_	  
@@ -32,12 +19,7 @@
 #include "typedefs.h"
 #endif
 
-#if defined(__GNUC__)
-#define	PACKED	__attribute__((packed))
-#else
-#pragma pack(1)
-#define	PACKED
-#endif
+#include <packed_section_start.h>
 
 #define	ETHER_ADDR_LEN		6
 
@@ -62,6 +44,7 @@
 #define	ETHER_TYPE_BRCM		0x886c		
 #define	ETHER_TYPE_802_1X	0x888e		
 #define	ETHER_TYPE_802_1X_PREAUTH 0x88c7	
+#define ETHER_TYPE_WAI		0x88b4		
 
 #define	ETHER_BRCM_SUBTYPE_LEN	4	
 #define	ETHER_BRCM_CRAM		1	
@@ -83,15 +66,15 @@
 
 #ifndef __INCif_etherh   
 
-struct	ether_header {
+BWL_PRE_PACKED_STRUCT struct ether_header {
 	uint8	ether_dhost[ETHER_ADDR_LEN];
 	uint8	ether_shost[ETHER_ADDR_LEN];
 	uint16	ether_type;
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 
-struct	ether_addr {
+BWL_PRE_PACKED_STRUCT struct	ether_addr {
 	uint8 octet[ETHER_ADDR_LEN];
-} PACKED;
+} BWL_POST_PACKED_STRUCT;
 #endif	
 
 #define ETHER_SET_LOCALADDR(ea)	(((uint8 *)(ea))[0] = (((uint8 *)(ea))[0] | 2))
@@ -129,9 +112,13 @@
 			    ((uint8 *)(ea))[4] |		\
 			    ((uint8 *)(ea))[5]) == 0)
 
-#undef PACKED
-#if !defined(__GNUC__)
-#pragma pack()
-#endif
+#define ETHER_MOVE_HDR(d, s) \
+do { \
+	struct ether_header t; \
+	t = *(struct ether_header *)(s); \
+	*(struct ether_header *)(d) = t; \
+} while (0)
+
+#include <packed_section_end.h>
 
 #endif 

=== modified file 'src/src/include/proto/wpa.h'
--- src/src/include/proto/wpa.h	2009-05-11 16:04:29 +0000
+++ src/src/include/proto/wpa.h	2010-02-14 19:58:58 +0000
@@ -1,28 +1,15 @@
 /*
  * Fundamental types and constants relating to WPA
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: wpa.h,v 1.16 2006/04/27 01:26:35 Exp $
+ * $Id: wpa.h,v 1.18.18.1 2009/10/22 07:38:44 Exp $
  */
 
 #ifndef _proto_wpa_h_
@@ -31,12 +18,7 @@
 #include <typedefs.h>
 #include <proto/ethernet.h>
 
-#if defined(__GNUC__)
-#define	PACKED	__attribute__((packed))
-#else
-#pragma pack(1)
-#define	PACKED
-#endif
+#include <packed_section_start.h>
 
 #define DOT11_RC_INVALID_WPA_IE		13	
 #define DOT11_RC_MIC_FAILURE		14	
@@ -52,57 +34,57 @@
 
 #define WPA2_PMKID_LEN	16
 
-typedef struct
+typedef BWL_PRE_PACKED_STRUCT struct
 {
 	uint8 tag;	
 	uint8 length;	
 	uint8 oui[3];	
 	uint8 oui_type;	
-	struct {
+	BWL_PRE_PACKED_STRUCT struct {
 		uint8 low;
 		uint8 high;
-	} PACKED version;	
-} PACKED wpa_ie_fixed_t;
+	} BWL_POST_PACKED_STRUCT version;	
+} BWL_POST_PACKED_STRUCT wpa_ie_fixed_t;
 #define WPA_IE_OUITYPE_LEN	4
 #define WPA_IE_FIXED_LEN	8
 #define WPA_IE_TAG_FIXED_LEN	6
 
-typedef struct {
+typedef BWL_PRE_PACKED_STRUCT struct {
 	uint8 tag;	
 	uint8 length;	
-	struct {
+	BWL_PRE_PACKED_STRUCT struct {
 		uint8 low;
 		uint8 high;
-	} PACKED version;	
-} PACKED wpa_rsn_ie_fixed_t;
+	} BWL_POST_PACKED_STRUCT version;	
+} BWL_POST_PACKED_STRUCT wpa_rsn_ie_fixed_t;
 #define WPA_RSN_IE_FIXED_LEN	4
 #define WPA_RSN_IE_TAG_FIXED_LEN	2
 typedef uint8 wpa_pmkid_t[WPA2_PMKID_LEN];
 
-typedef struct
+typedef BWL_PRE_PACKED_STRUCT struct
 {
 	uint8 oui[3];
 	uint8 type;
-} PACKED wpa_suite_t, wpa_suite_mcast_t;
+} BWL_POST_PACKED_STRUCT wpa_suite_t, wpa_suite_mcast_t;
 #define WPA_SUITE_LEN	4
 
-typedef struct
+typedef BWL_PRE_PACKED_STRUCT struct
 {
-	struct {
+	BWL_PRE_PACKED_STRUCT struct {
 		uint8 low;
 		uint8 high;
-	} PACKED count;
+	} BWL_POST_PACKED_STRUCT count;
 	wpa_suite_t list[1];
-} PACKED wpa_suite_ucast_t, wpa_suite_auth_key_mgmt_t;
+} BWL_POST_PACKED_STRUCT wpa_suite_ucast_t, wpa_suite_auth_key_mgmt_t;
 #define WPA_IE_SUITE_COUNT_LEN	2
-typedef struct
+typedef BWL_PRE_PACKED_STRUCT struct
 {
-	struct {
+	BWL_PRE_PACKED_STRUCT struct {
 		uint8 low;
 		uint8 high;
-	} PACKED count;
+	} BWL_POST_PACKED_STRUCT count;
 	wpa_pmkid_t list[1];
-} PACKED wpa_pmkid_list_t;
+} BWL_POST_PACKED_STRUCT wpa_pmkid_list_t;
 
 #define WPA_CIPHER_NONE		0	
 #define WPA_CIPHER_WEP_40	1	
@@ -111,12 +93,29 @@
 #define WPA_CIPHER_AES_CCM	4	
 #define WPA_CIPHER_WEP_104	5	
 
+#ifdef BCMWAPI_WAI
+#define WAPI_CIPHER_NONE	WPA_CIPHER_NONE
+#define WAPI_CIPHER_SMS4	11
+
+#define WAPI_CSE_WPI_SMS4	1
+#endif 
+
 #define IS_WPA_CIPHER(cipher)	((cipher) == WPA_CIPHER_NONE || \
 				 (cipher) == WPA_CIPHER_WEP_40 || \
 				 (cipher) == WPA_CIPHER_WEP_104 || \
 				 (cipher) == WPA_CIPHER_TKIP || \
 				 (cipher) == WPA_CIPHER_AES_OCB || \
 				 (cipher) == WPA_CIPHER_AES_CCM)
+#ifdef BCMWAPI_WAI
+#define IS_WAPI_CIPHER(cipher)	((cipher) == WAPI_CIPHER_NONE || \
+				 (cipher) == WAPI_CSE_WPI_SMS4)
+
+#define WAPI_CSE_WPI_2_CIPHER(cse) ((cse) == WAPI_CSE_WPI_SMS4 ? \
+				WAPI_CIPHER_SMS4 : WAPI_CIPHER_NONE)
+
+#define WAPI_CIPHER_2_CSE_WPI(cipher) ((cipher) == WAPI_CIPHER_SMS4 ? \
+				WAPI_CSE_WPI_SMS4 : WAPI_CIPHER_NONE)
+#endif 
 
 #define WPA_TKIP_CM_DETECT	60	
 #define WPA_TKIP_CM_BLOCK	60	
@@ -143,9 +142,19 @@
 
 #define	WPA_CAP_WPA2_PREAUTH		RSN_CAP_PREAUTH
 
-#undef PACKED
-#if !defined(__GNUC__)
-#pragma pack()
-#endif
+#ifdef BCMWAPI_WAI
+#define WAPI_CAP_PREAUTH		RSN_CAP_PREAUTH
+
+#define WAPI_WAI_REQUEST		0x00F1
+#define WAPI_UNICAST_REKEY		0x00F2
+#define WAPI_STA_AGING			0x00F3
+#define WAPI_MUTIL_REKEY		0x00F4
+#define WAPI_STA_STATS			0x00F5
+
+#define WAPI_USK_REKEY_COUNT		0x4000000 
+#define WAPI_MSK_REKEY_COUNT		0x4000000 
+#endif 
+
+#include <packed_section_end.h>
 
 #endif 

=== modified file 'src/src/include/typedefs.h'
--- src/src/include/typedefs.h	2009-05-11 16:04:29 +0000
+++ src/src/include/typedefs.h	2010-02-14 19:58:58 +0000
@@ -1,26 +1,12 @@
 /*
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
- *
- * $Id: typedefs.h,v 1.85.32.8 2009/02/26 17:07:08 Exp $
+ * $Id: typedefs.h,v 1.96.28.1.8.1 2009/11/30 22:27:30 Exp $
  */
 
 #ifndef _TYPEDEFS_H_
@@ -45,6 +31,13 @@
 typedef unsigned long long int uintptr;
 #endif
 
+#if defined(TARGETOS_nucleus)
+
+#include <stddef.h>
+
+#define TYPEDEF_FLOAT_T
+#endif   
+
 #if defined(LINUX_PORT)
 #define TYPEDEF_UINT
 #define TYPEDEF_USHORT
@@ -62,6 +55,8 @@
 #define TYPEDEF_UINT64
 #endif
 
+#if !defined(__BOB__) && !defined(TARGETOS_nucleus)
+
 #if defined(__KERNEL__)
 
 #if defined(LINUX_PORT)
@@ -74,6 +69,8 @@
 
 #endif 
 
+#endif 
+
 #define USE_TYPEDEF_DEFAULTS
 
 #ifdef USE_TYPEDEF_DEFAULTS
@@ -179,18 +176,24 @@
 #define	PTRSZ	sizeof(char*)
 #endif
 
+#if defined(__GNUC__)
+	#define BWL_COMPILER_GNU
+#elif defined(__CC_ARM) && __CC_ARM
+	#define BWL_COMPILER_ARMCC
+#else
+	#error "Unknown compiler!"
+#endif 
+
 #ifndef INLINE
-
-#if defined(__GNUC__)
-
-#define INLINE __inline__
-
-#else
-
-#define INLINE
-
-#endif 
-
+	#if defined(BWL_COMPILER_MICROSOFT)
+		#define INLINE __inline
+	#elif defined(BWL_COMPILER_GNU)
+		#define INLINE __inline__
+	#elif defined(BWL_COMPILER_ARMCC)
+		#define INLINE	__inline
+	#else
+		#define INLINE
+	#endif 
 #endif 
 
 #undef TYPEDEF_BOOL
@@ -213,6 +216,8 @@
 
 #endif 
 
+#define UNUSED_PARAMETER(x) (void)(x)
+
 #include <bcmdefs.h>
 
 #endif 

=== modified file 'src/src/include/wlioctl.h'
--- src/src/include/wlioctl.h	2009-05-11 16:04:29 +0000
+++ src/src/include/wlioctl.h	2010-02-14 19:58:58 +0000
@@ -4,28 +4,15 @@
  *
  * Definitions subject to change without notice.
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: wlioctl.h,v 1.620.2.56 2009/02/26 17:07:07 Exp $
+ * $Id: wlioctl.h,v 1.712.2.17.2.3 2010/01/11 23:56:38 Exp $
  */
 
 #ifndef _wlioctl_h_
@@ -38,11 +25,42 @@
 #include <proto/802.11.h>
 #include <bcmwifi.h>
 
-#if !defined(__GNUC__)
-#pragma pack(push, 8)
-#endif
-
-#define	WL_BSS_INFO_VERSION	108		
+#include <packed_section_start.h>
+
+#define	LEGACY2_WL_BSS_INFO_VERSION	108		
+
+typedef struct wl_bss_info_108 {
+	uint32		version;		
+	uint32		length;			
+	struct ether_addr BSSID;
+	uint16		beacon_period;		
+	uint16		capability;		
+	uint8		SSID_len;
+	uint8		SSID[32];
+	struct {
+		uint	count;			
+		uint8	rates[16];		
+	} rateset;				
+	chanspec_t	chanspec;		
+	uint16		atim_window;		
+	uint8		dtim_period;		
+	int16		RSSI;			
+	int8		phy_noise;		
+
+	uint8		n_cap;			
+	uint32		nbss_cap;		
+	uint8		ctl_ch;			
+	uint32		reserved32[1];		
+	uint8		flags;			
+	uint8		reserved[3];		
+	uint8		basic_mcs[MCSSET_LEN];	
+
+	uint16		ie_offset;		
+	uint32		ie_length;		
+
+} wl_bss_info_108_t;
+
+#define	WL_BSS_INFO_VERSION	109		
 
 typedef struct wl_bss_info {
 	uint32		version;		
@@ -72,6 +90,7 @@
 
 	uint16		ie_offset;		
 	uint32		ie_length;		
+	int16		SNR;			
 
 } wl_bss_info_t;
 
@@ -106,7 +125,13 @@
 #define WL_ISCAN_RESULTS_FIXED_SIZE \
 	(WL_SCAN_RESULTS_FIXED_SIZE + OFFSETOF(wl_iscan_results_t, results))
 
-#define WL_NUMRATES		255	
+typedef struct wl_probe_params {
+	wlc_ssid_t ssid;
+	struct ether_addr bssid;
+	struct ether_addr mac;
+} wl_probe_params_t;
+
+#define WL_NUMRATES		16	
 typedef struct wl_rateset {
 	uint32	count;			
 	uint8	rates[WL_NUMRATES];	
@@ -182,17 +207,20 @@
 
 #define WPA2_AUTH_UNSPECIFIED	0x0040	
 #define WPA2_AUTH_PSK		0x0080	
+#ifdef BCMWAPI_WAI
+#define WAPI_AUTH_NONE		WPA_AUTH_NONE	
+#define WAPI_AUTH_UNSPECIFIED	0x0400	
+#define WAPI_AUTH_PSK		0x0800	
+#endif 
 
 #define	MAXPMKID		16
 
-typedef struct _pmkid
-{
+typedef struct _pmkid {
 	struct ether_addr	BSSID;
 	uint8			PMKID[WPA2_PMKID_LEN];
 } pmkid_t;
 
-typedef struct _pmkid_list
-{
+typedef struct _pmkid_list {
 	uint32	npmkid;
 	pmkid_t	pmkid[1];
 } pmkid_list_t;
@@ -207,6 +235,11 @@
 	pmkid_cand_t	pmkid_cand[1];
 } pmkid_cand_list_t;
 
+typedef struct {
+	uint32	val;
+	struct ether_addr ea;
+} scb_val_t;
+
 typedef struct channel_info {
 	int hw_channel;
 	int target_channel;
@@ -218,16 +251,13 @@
 	struct ether_addr ea[1];	
 };
 
-typedef struct {
-	uint32	val;
-	struct ether_addr ea;
-} scb_val_t;
-
-typedef struct {
-	int ac;
-	uint8 val;
-	struct ether_addr ea;
-} link_val_t;
+typedef struct get_pktcnt {
+	uint rx_good_pkt;
+	uint rx_bad_pkt;
+	uint tx_good_pkt;
+	uint tx_bad_pkt;
+	uint rx_ocast_good_pkt; 
+} get_pktcnt_t;
 
 typedef struct wl_ioctl {
 	uint cmd;	
@@ -248,6 +278,7 @@
 
 #define	WLC_IOCTL_MAXLEN	8192		
 #define	WLC_IOCTL_SMLEN		256		
+#define WLC_IOCTL_MEDLEN        1536    	
 #define WLC_SAMPLECOLLECT_MAXLEN	10240	
 
 #define WLC_GET_MAGIC				0
@@ -549,14 +580,24 @@
 #define WLC_NPHY_SAMPLE_COLLECT			307	
 #define WLC_UM_PRIV				308	
 #define WLC_GET_CMD				309
-#define WLC_LAST				310	
+
+#define WLC_SET_INTERFERENCE_OVERRIDE_MODE	311	
+#define WLC_GET_INTERFERENCE_OVERRIDE_MODE	312	
+#define WLC_GET_WAI_RESTRICT			313	
+#define WLC_SET_WAI_RESTRICT			314	
+#define WLC_SET_WAI_REKEY			315	
+#define WLC_LAST				316	
+
+#define WL_AUTH_OPEN_SYSTEM		0	
+#define WL_AUTH_SHARED_KEY		1	
+#define WL_AUTH_OPEN_SHARED		2	
 
 #define WL_RADIO_SW_DISABLE		(1<<0)
 #define WL_RADIO_HW_DISABLE		(1<<1)
 #define WL_RADIO_MPC_DISABLE		(1<<2)
 #define WL_RADIO_COUNTRY_DISABLE	(1<<3)	
 
-#define WL_TXPWR_OVERRIDE	(1<<31)
+#define WL_TXPWR_OVERRIDE	(1U<<31)
 
 #define WL_PHY_PAVARS_LEN	6	
 
@@ -568,6 +609,8 @@
 	uint16	mcspo[8];
 } wl_po_t;
 
+#define WLC_TXPWR_MAX		(127)	
+
 #define WL_DIAG_INTERRUPT			1	
 #define WL_DIAG_LOOPBACK			2	
 #define WL_DIAG_MEMORY				3	
@@ -607,6 +650,7 @@
 #define	WLC_PHY_TYPE_N		4
 #define	WLC_PHY_TYPE_LP		5
 #define	WLC_PHY_TYPE_SSN	6
+#define	WLC_PHY_TYPE_LCN	8
 #define	WLC_PHY_TYPE_NULL	0xf
 
 #define WLC_MACMODE_DISABLED	0	
@@ -658,6 +702,7 @@
 #define PM_MAX	1
 #define PM_FAST 2
 
+#define	INTERFERE_OVRRIDE_OFF	-1	
 #define	INTERFERE_NONE	0	
 #define	NON_WLAN	1	
 #define	WLAN_MANUAL	2	
@@ -698,17 +743,17 @@
 #define WL_ASSOC_VAL		0x00000100
 #define WL_PRUSR_VAL		0x00000200
 #define WL_PS_VAL		0x00000400
-#define WL_TXPWR_VAL		0x00000800
+#define WL_TXPWR_VAL		0x00000800	
 #define WL_PORT_VAL		0x00001000
 #define WL_DUAL_VAL		0x00002000
 #define WL_WSEC_VAL		0x00004000
 #define WL_WSEC_DUMP_VAL	0x00008000
 #define WL_LOG_VAL		0x00010000
-#define WL_NRSSI_VAL		0x00020000
-#define WL_LOFT_VAL		0x00040000
+#define WL_NRSSI_VAL		0x00020000	
+#define WL_LOFT_VAL		0x00040000	
 #define WL_REGULATORY_VAL	0x00080000
-#define WL_PHYCAL_VAL		0x00100000
-#define WL_RADAR_VAL		0x00200000
+#define WL_PHYCAL_VAL		0x00100000	
+#define WL_RADAR_VAL		0x00200000	
 #define WL_MPC_VAL		0x00400000
 #define WL_APSTA_VAL		0x00800000
 #define WL_DFS_VAL		0x01000000
@@ -725,7 +770,10 @@
 #define WL_WOWL_VAL		0x00000004
 #define WL_COEX_VAL		0x00000008
 #define WL_RTDC_VAL		0x00000010
-#define WL_PHYDBG_VAL		0x00000020
+#define WL_PROTO_VAL		0x00000020
+#define WL_BTA_VAL		0x00000040
+#define WL_CHANINT_VAL		0x00000080
+#define WL_THERMAL_VAL		0x00000100	
 
 #define	WL_LED_NUMGPIO		16	
 
@@ -806,13 +854,9 @@
 	uint8 octets[3];
 };
 
-#if !defined(__GNUC__)
-#pragma pack(pop)
-#endif
-
 #define	NFIFO			6	
 
-#define	WL_CNT_T_VERSION	5	
+#define	WL_CNT_T_VERSION	6	
 
 typedef struct {
 	uint16	version;	
@@ -986,6 +1030,11 @@
 
 	uint32	rfdisable;	
 	uint32	bphy_rxcrsglitch;	
+
+	uint32	txmpdu_sgi;	
+	uint32	rxmpdu_sgi;	
+	uint32	txmpdu_stbc;	
+	uint32	rxmpdu_stbc;	
 } wl_cnt_t;
 
 #define WL_WME_CNT_VERSION	1	
@@ -1010,6 +1059,11 @@
 
 } wl_wme_cnt_t;
 
+struct wl_msglevel2 {
+	uint32 low;
+	uint32 high;
+};
+
 #define WLC_ROAM_TRIGGER_DEFAULT	0 
 #define WLC_ROAM_TRIGGER_BANDWIDTH	1 
 #define WLC_ROAM_TRIGGER_DISTANCE	2 
@@ -1018,8 +1072,7 @@
 
 enum {
 	PFN_LIST_ORDER,
-	PFN_RSSI,
-	PFN_AUTO_CONNECT
+	PFN_RSSI
 };
 
 enum {
@@ -1029,21 +1082,21 @@
 
 #define SORT_CRITERIA_BIT		0
 #define AUTO_NET_SWITCH_BIT		1
-#define ENABLE_BKGRD_SCAN_BIT	2
+#define ENABLE_BKGRD_SCAN_BIT		2
 #define IMMEDIATE_SCAN_BIT		3
 #define	AUTO_CONNECT_BIT		4
 
 #define SORT_CRITERIA_MASK		0x01
-#define AUTO_NET_SWITCH_MASK	0x02
-#define ENABLE_BKGRD_SCAN_MASK	0x04
+#define AUTO_NET_SWITCH_MASK		0x02
+#define ENABLE_BKGRD_SCAN_MASK		0x04
 #define IMMEDIATE_SCAN_MASK		0x08
 #define	AUTO_CONNECT_MASK		0x10
 
 #define PFN_VERSION			1
 
 typedef struct wl_pfn_param {
-	int32 version;				
-	int32 scan_freq;			
+	int32 version;			
+	int32 scan_freq;		
 	int32 lost_network_timeout;	
 	int16 flags;			
 	int16 rssi_margin;		
@@ -1065,177 +1118,13 @@
 #define TOE_TX_CSUM_OL		0x00000001
 #define TOE_RX_CSUM_OL		0x00000002
 
-#define TOE_ERRTEST_TX_CSUM	0x00000001
-#define TOE_ERRTEST_RX_CSUM	0x00000002
-#define TOE_ERRTEST_RX_CSUM2	0x00000004
-
-struct toe_ol_stats_t {
-
-	uint32 tx_summed;
-
-	uint32 tx_iph_fill;
-	uint32 tx_tcp_fill;
-	uint32 tx_udp_fill;
-	uint32 tx_icmp_fill;
-
-	uint32 rx_iph_good;
-	uint32 rx_iph_bad;
-	uint32 rx_tcp_good;
-	uint32 rx_tcp_bad;
-	uint32 rx_udp_good;
-	uint32 rx_udp_bad;
-	uint32 rx_icmp_good;
-	uint32 rx_icmp_bad;
-
-	uint32 tx_tcp_errinj;
-	uint32 tx_udp_errinj;
-	uint32 tx_icmp_errinj;
-
-	uint32 rx_tcp_errinj;
-	uint32 rx_udp_errinj;
-	uint32 rx_icmp_errinj;
-};
-
-#define ARP_OL_AGENT		0x00000001
-#define ARP_OL_SNOOP		0x00000002
-#define ARP_OL_HOST_AUTO_REPLY	0x00000004
-#define ARP_OL_PEER_AUTO_REPLY	0x00000008
-
-#define ARP_ERRTEST_REPLY_PEER	0x1
-#define ARP_ERRTEST_REPLY_HOST	0x2
-
-#define ARP_MULTIHOMING_MAX	8	
-
-struct arp_ol_stats_t {
-	uint32  host_ip_entries;	
-	uint32  host_ip_overflow;	
-
-	uint32  arp_table_entries;	
-	uint32  arp_table_overflow;	
-
-	uint32  host_request;		
-	uint32  host_reply;		
-	uint32  host_service;		
-
-	uint32  peer_request;		
-	uint32  peer_request_drop;	
-	uint32  peer_reply;		
-	uint32  peer_reply_drop;	
-	uint32  peer_service;		
-};
-
-typedef struct wl_keep_alive_pkt {
-
-	uint32  period_msec;
-
-	uint16   len_bytes;
-
-	uint8   data[1];
-
-} wl_keep_alive_pkt_t;
-
-#define WL_KEEP_ALIVE_FIXED_LEN	OFFSETOF(wl_keep_alive_pkt_t, data)
-
-typedef enum WL_PKT_FILTER_TYPE {
-
-	WL_PKT_FILTER_TYPE_PATTERN_MATCH
-
-} WL_PKT_FILTER_TYPE;
-
-typedef struct wl_pkt_filter_pattern {
-
-	uint32  offset;
-
-	uint32  size_bytes;
-
-	uint8   mask_and_pattern[1];
-
-} wl_pkt_filter_pattern_t;
-
-typedef struct wl_pkt_filter {
-
-	uint32  id;
-
-	uint32   type;
-
-	uint32   negate_match;
-
-	union
-	{
-
-		wl_pkt_filter_pattern_t    pattern;
-
-	} u;
-
-} wl_pkt_filter_t;
-
-#define WL_PKT_FILTER_FIXED_LEN	OFFSETOF(wl_pkt_filter_t, u)
-
-#define WL_PKT_FILTER_PATTERN_FIXED_LEN	OFFSETOF(wl_pkt_filter_pattern_t, mask_and_pattern)
-
-typedef struct wl_pkt_filter_enable {
-
-	uint32  id;
-
-	uint32   enable;
-
-} wl_pkt_filter_enable_t;
-
-typedef struct wl_pkt_filter_list {
-
-	uint32				num;
-
-	wl_pkt_filter_t	filter[1];
-
-} wl_pkt_filter_list_t;
-
-#define WL_PKT_FILTER_LIST_FIXED_LEN	OFFSETOF(wl_pkt_filter_list_t, filter)
-
-typedef struct wl_pkt_filter_stats {
-
-	uint32	num_pkts_matched;
-
-	uint32	num_pkts_forwarded;
-
-	uint32	num_pkts_discarded;
-
-} wl_pkt_filter_stats_t;
-
-typedef struct wl_seq_cmd_ioctl {
-	uint32 cmd;		
-	uint32 len;		
-} wl_seq_cmd_ioctl_t;
-
-#define WL_SEQ_CMD_ALIGN_BYTES	4
-
-#define WL_SEQ_CMDS_GET_IOCTL_FILTER(cmd) \
-	(((cmd) == WLC_GET_MAGIC)		|| \
-	 ((cmd) == WLC_GET_VERSION)	|| \
-	 ((cmd) == WLC_GET_AP)			|| \
-	 ((cmd) == WLC_GET_INSTANCE))
-
-#define WL_PKTENG_PER_TX_START			0x01
-#define WL_PKTENG_PER_TX_STOP			0x02
-#define WL_PKTENG_PER_RX_START			0x04
-#define WL_PKTENG_PER_RX_WITH_ACK_START 	0x05
-#define WL_PKTENG_PER_TX_WITH_ACK_START 	0x06
-#define WL_PKTENG_PER_RX_STOP			0x08
-
-typedef struct wl_pkteng {
-	uint32 flags;
-	uint32 delay;		
-	uint32 nframes;		
-	uint32 length;		
-	uint8  seqno;		
-	struct ether_addr dest;	
-	struct ether_addr src;	
-} wl_pkteng_t;
-
-typedef struct wl_pkteng_stats {
-	uint32 lostfrmcnt;		
-	int32 rssi;		
-	int32 snr;			
-} wl_pkteng_stats_t;
+typedef struct wl_sslpnphy_papd_debug_data {
+	uint8 psat_pwr;
+	uint8 psat_indx;
+	uint8 final_idx;
+	uint8 start_idx;
+	int32 min_phase;
+} wl_sslpnphy_papd_debug_data_t;
 
 #define WL_WOWL_MAGIC	(1 << 0)	
 #define WL_WOWL_NET	(1 << 1)	
@@ -1243,15 +1132,19 @@
 #define WL_WOWL_RETR	(1 << 3)	
 #define WL_WOWL_BCN	(1 << 4)	
 #define WL_WOWL_TST	(1 << 5)	
+#define WL_WOWL_M1      (1 << 6)        
+#define WL_WOWL_EAPID   (1 << 7)        
+#define WL_WOWL_KEYROT  (1 << 14)       
 #define WL_WOWL_BCAST	(1 << 15)	
 
-#define MAGIC_PKT_MINLEN 102 
+#define MAGIC_PKT_MINLEN 102	
 
 typedef struct {
 	uint masksize;		
 	uint offset;		
 	uint patternoffset;	
 	uint patternsize;	
+	ulong id;		
 
 } wl_wowl_pattern_t;
 
@@ -1302,6 +1195,7 @@
 	int16	chanwidth_transition_delay;
 	int16	activity_threshold;
 } wl_obss_scan_arg_t;
+
 #define WL_OBSS_SCAN_PARAM_LEN	sizeof(wl_obss_scan_arg_t)
 #define WL_MIN_NUM_OBSS_SCAN_ARG 7	
 
@@ -1310,6 +1204,16 @@
 #define	WL_COEX_40MHZ_INTOLERANT	0x02
 #define	WL_COEX_WIDTH20			0x04
 
+#define	WLC_RSSI_INVALID	 0	
+
+#define MAX_RSSI_LEVELS 8
+
+typedef struct wl_rssi_event {
+	uint32 rate_limit_msec;		
+	uint8 num_rssi_levels;		
+	int8 rssi_levels[MAX_RSSI_LEVELS];	
+} wl_rssi_event_t;
+
 typedef struct wl_action_obss_coex_req {
 	uint8 info;
 	uint8 num;
@@ -1323,13 +1227,13 @@
 #define LOG_MODULE_COMMON	0x0001
 #define LOG_MODULE_ASSOC	0x0002
 #define LOG_MODULE_EVENT	0x0004
-#define MAX_LOG_MODULE		3
+#define LOG_MODULE_MAX		3			
 
-#define LOG_LEVEL_DISABLE	0
-#define LOG_LEVEL_ERR		1
-#define LOG_LEVEL_WARN		2
-#define LOG_LEVEL_INFO		3
-#define MAX_LOG_LEVEL		(LOG_LEVEL_INFO + 1)
+#define WL_LOG_LEVEL_DISABLE	0
+#define WL_LOG_LEVEL_ERR	1
+#define WL_LOG_LEVEL_WARN	2
+#define WL_LOG_LEVEL_INFO	3
+#define WL_LOG_LEVEL_MAX	WL_LOG_LEVEL_INFO	
 
 #define LOG_FLAG_EVENT		1
 
@@ -1408,11 +1312,33 @@
 	FMTSTR_FATAL_ERROR_ID = 25,
 	FMTSTR_AUTH_FAIL_ID = 26,
 	FMTSTR_ASSOC_FAIL_ID = 27,
+	FMTSTR_IBSS_FAIL_ID = 28,
+	FMTSTR_EXTAP_FAIL_ID = 29,
 	FMTSTR_MAX_ID
 } log_fmtstr_id_t;
 
+#include <packed_section_end.h>
+
+#include <packed_section_start.h>
+
+typedef BWL_PRE_PACKED_STRUCT struct sta_prbreq_wps_ie_hdr {
+	struct ether_addr staAddr;
+	uint16 ieLen;
+} BWL_POST_PACKED_STRUCT sta_prbreq_wps_ie_hdr_t;
+
+typedef BWL_PRE_PACKED_STRUCT struct sta_prbreq_wps_ie_data {
+	sta_prbreq_wps_ie_hdr_t hdr;
+	uint8 ieData[1];
+} BWL_POST_PACKED_STRUCT sta_prbreq_wps_ie_data_t;
+
+typedef BWL_PRE_PACKED_STRUCT struct sta_prbreq_wps_ie_list {
+	uint32 totLen;
+	uint8 ieDataList[1];
+} BWL_POST_PACKED_STRUCT sta_prbreq_wps_ie_list_t;
+
+#include <packed_section_end.h>
+
 #define ASSERTLOG_CUR_VER	0x0100
-
 #define MAX_ASSRTSTR_LEN	64
 
 typedef struct assert_record {
@@ -1431,4 +1357,68 @@
 #define LOGRRC_FIX_LEN	8
 #define IOBUF_ALLOWED_NUM_OF_LOGREC(type, len) ((len - LOGRRC_FIX_LEN)/sizeof(type))
 
+#ifdef BCMWAPI_WAI
+#define IV_LEN 16
+struct wapi_sta_msg_t
+{
+	uint16	msg_type;
+	uint16	datalen;
+	uint8	vap_mac[6];
+	uint8	reserve_data1[2];
+	uint8	sta_mac[6];
+	uint8	reserve_data2[2];
+	uint8	gsn[IV_LEN];
+	uint8	wie[256];
+};
+#endif 
+
+#ifdef PHYMON
+
+#define PHYMON_VERSION 1
+
+typedef struct wl_phycal_core_state {
+
+	int16 tx_iqlocal_a;
+	int16 tx_iqlocal_b;
+	int8 tx_iqlocal_ci;
+	int8 tx_iqlocal_cq;
+	int8 tx_iqlocal_di;
+	int8 tx_iqlocal_dq;
+	int8 tx_iqlocal_ei;
+	int8 tx_iqlocal_eq;
+	int8 tx_iqlocal_fi;
+	int8 tx_iqlocal_fq;
+
+	int16 rx_iqcal_a;
+	int16 rx_iqcal_b;
+
+	uint8 tx_iqlocal_pwridx; 
+	uint32 papd_epsilon_table[64]; 
+	int16 papd_epsilon_offset; 
+	uint8 curr_tx_pwrindex; 
+	int8 idle_tssi; 
+	int8 est_tx_pwr; 
+	int8 est_rx_pwr; 
+	uint16 rx_gaininfo; 
+	uint16 init_gaincode; 
+	int8 estirr_tx;
+	int8 estirr_rx;
+
+} wl_phycal_core_state_t;
+
+typedef struct wl_phycal_state {
+	int version;
+	int8 num_phy_cores; 
+	int8 curr_temperature; 
+	chanspec_t chspec; 
+	bool aci_state; 
+	uint16 crsminpower; 
+	uint16 crsminpowerl; 
+	uint16 crsminpoweru; 
+	wl_phycal_core_state_t phycal_core[1];
+} wl_phycal_state_t;
+
+#define WL_PHYCAL_STAT_FIXED_LEN OFFSETOF(wl_phycal_state_t, phycal_core)
+#endif 
+
 #endif 

=== modified file 'src/src/shared/linux_osl.c'
--- src/src/shared/linux_osl.c	2009-05-11 16:04:29 +0000
+++ src/src/shared/linux_osl.c	2010-02-14 19:58:58 +0000
@@ -1,28 +1,15 @@
 /*
  * Linux OS Independent Layer
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: linux_osl.c,v 1.127.2.18 2009/02/26 17:07:07 Exp $
+ * $Id: linux_osl.c,v 1.152.18.5.4.1 2009/11/13 00:32:19 Exp $
  */
 
 #define LINUX_PORT
@@ -36,6 +23,8 @@
 #include <linux/delay.h>
 #include <pcicfg.h>
 
+#include <linux/fs.h>
+
 #define PCI_CFG_RETRY 		10
 
 #define OS_HANDLE_MAGIC		0x1234abcd	
@@ -49,6 +38,15 @@
 	char	file[BCM_MEM_FILENAME_LEN];
 } bcm_mem_link_t;
 
+#if defined(DSLCPE_DELAY_NOT_YET)
+struct shared_osl {
+	int long_delay;
+	spinlock_t *lock;
+	void *wl;
+	unsigned long MIPS;
+};
+#endif
+
 struct osl_info {
 	osl_pubinfo_t pub;
 	uint magic;
@@ -59,9 +57,9 @@
 	bcm_mem_link_t *dbgmem_list;
 };
 
-bool g_assert_bypass = FALSE;
+uint32 g_assert_type = 0;
 
-static int16 linuxbcmerrormap[] =  \
+static int16 linuxbcmerrormap[] =
 {	0, 			
 	-EINVAL,		
 	-EINVAL,		
@@ -102,11 +100,11 @@
 	-EINVAL,		
 	-EIO,			
 	-EIO,			
-	-EINVAL			
+	-EINVAL,		
 
 #if BCME_LAST != -40
 #error "You need to add a OS error translation in the linuxbcmerrormap \
-	for new error code defined in bcmuitls.h"
+	for new error code defined in bcmutils.h"
 #endif 
 };
 
@@ -207,12 +205,13 @@
 		nskb = skb->next;
 		skb->next = NULL;
 
-		if (skb->destructor) {
-
-			dev_kfree_skb_any(skb);
-		} else {
-
-			dev_kfree_skb(skb);
+		{
+			if (skb->destructor)
+
+				dev_kfree_skb_any(skb);
+			else
+
+				dev_kfree_skb(skb);
 		}
 
 		osh->pub.pktalloced--;
@@ -353,10 +352,15 @@
 }
 
 void*
-osl_dma_alloc_consistent(osl_t *osh, uint size, ulong *pap)
+osl_dma_alloc_consistent(osl_t *osh, uint size, uint16 align_bits, uint *alloced, ulong *pap)
 {
+	uint16 align = (1 << align_bits);
 	ASSERT((osh && (osh->magic == OS_HANDLE_MAGIC)));
 
+	if (!ISALIGNED(DMA_CONSISTENT_ALIGN, align))
+		size += align;
+	*alloced = size;
+
 	return (pci_alloc_consistent(osh->pdev, size, (dma_addr_t*)pap));
 }
 
@@ -371,13 +375,11 @@
 uint BCMFASTPATH
 osl_dma_map(osl_t *osh, void *va, uint size, int direction)
 {
+	int dir;
+
 	ASSERT((osh && (osh->magic == OS_HANDLE_MAGIC)));
-
-	if (direction == DMA_TX)
-		return (pci_map_single(osh->pdev, va, size, PCI_DMA_TODEVICE));
-	else {
-		return (pci_map_single(osh->pdev, va, size, PCI_DMA_FROMDEVICE));
-	}
+	dir = (direction == DMA_TX)? PCI_DMA_TODEVICE: PCI_DMA_FROMDEVICE;
+	return (pci_map_single(osh->pdev, va, size, dir));
 }
 
 void BCMFASTPATH
@@ -395,8 +397,19 @@
 osl_assert(char *exp, char *file, int line)
 {
 	char tempbuf[256];
+	char *basename;
+
+	basename = strrchr(file, '/');
+
+	if (basename)
+		basename++;
+
+	if (!basename)
+		basename = file;
+
 #ifdef BCMDBG_ASSERT
-	snprintf(tempbuf, 256, "assertion \"%s\" failed: file \"%s\", line %d\n", exp, file, line);
+	snprintf(tempbuf, 256, "assertion \"%s\" failed: file \"%s\", line %d\n",
+		exp, basename, line);
 
 	if (!in_interrupt()) {
 		const int delay = 3;
@@ -405,7 +418,7 @@
 		set_current_state(TASK_INTERRUPTIBLE);
 		schedule_timeout(delay * HZ);
 	}
-	if (!g_assert_bypass)
+	if (g_assert_type == 0)
 		panic("%s", tempbuf);
 #endif
 
@@ -439,6 +452,12 @@
 	return (p);
 }
 
+uint32
+osl_sysuptime(void)
+{
+	return ((uint32)jiffies * (1000 / HZ));
+}
+
 uint
 osl_pktalloced(osl_t *osh)
 {
@@ -449,7 +468,7 @@
 osl_printf(const char *format, ...)
 {
 	va_list args;
-	char buf[1024];
+	static char buf[1024];
 	int len;
 
 	va_start(args, format);
@@ -608,6 +627,12 @@
 	return ((void*)va);
 }
 
+void *
+osl_cached(void *va)
+{
+	return ((void*)va);
+}
+
 uint
 osl_getcycles(void)
 {
@@ -757,3 +782,39 @@
 	}
 	return (void *)pkt;
 }
+
+void *
+osl_os_open_image(char *filename)
+{
+	struct file *fp;
+
+	fp = filp_open(filename, O_RDONLY, 0);
+
+	 if (IS_ERR(fp))
+		 fp = NULL;
+
+	 return fp;
+}
+
+int
+osl_os_get_image_block(char *buf, int len, void *image)
+{
+	struct file *fp = (struct file *)image;
+	int rdlen;
+
+	if (!image)
+		return 0;
+
+	rdlen = kernel_read(fp, fp->f_pos, buf, len);
+	if (rdlen > 0)
+		fp->f_pos += rdlen;
+
+	return rdlen;
+}
+
+void
+osl_os_close_image(void *image)
+{
+	if (image)
+		filp_close((struct file *)image, NULL);
+}

=== added directory 'src/src/wl/phy'
=== added file 'src/src/wl/phy/phy_version.h'
--- src/src/wl/phy/phy_version.h	1970-01-01 00:00:00 +0000
+++ src/src/wl/phy/phy_version.h	2010-02-14 19:58:58 +0000
@@ -0,0 +1,33 @@
+/*
+ * Copyright (C) 2010, Broadcom Corporation
+ * All Rights Reserved.
+ * 
+ * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
+ * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
+ * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
+ * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
+ *
+ * $Id: phy_version.h.in,v 1.2 2009/06/18 06:28:33 Exp $
+ *
+*/
+
+#ifndef phy_version_h_
+#define phy_version_h_
+
+#define	PHY_MAJOR_VERSION		1
+
+#define	PHY_MINOR_VERSION		52
+
+#define	PHY_RC_NUMBER		14
+
+#define	PHY_INCREMENTAL_NUMBER	0
+
+#define	PHY_BUILD_NUMBER		0
+
+#define	PHY_VERSION			1, 52, 14, 0
+
+#define	PHY_VERSION_NUM		0x01340e00
+
+#define	PHY_VERSION_STR		"1.52.14.0"
+
+#endif 

=== modified file 'src/src/wl/sys/wl_dbg.h'
--- src/src/wl/sys/wl_dbg.h	2009-05-11 16:04:29 +0000
+++ src/src/wl/sys/wl_dbg.h	2010-02-14 19:58:58 +0000
@@ -2,46 +2,38 @@
  * Minimal debug/trace/assert driver definitions for
  * Broadcom 802.11 Networking Adapter.
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: wl_dbg.h,v 1.99.2.5 2008/11/12 23:41:23 Exp $
+ * $Id: wl_dbg.h,v 1.112.2.1.18.1 2009/11/04 01:50:44 Exp $
  */
 
 #ifndef _wl_dbg_h_
 #define _wl_dbg_h_
 
-#ifdef	BCMDBG
-
-#define	WL_ERROR(args)		do {if (wl_msg_level & WL_ERROR_VAL) printf args;} while (0)
-#define	WL_TRACE(args)		do {if (wl_msg_level & WL_TRACE_VAL) printf args;} while (0)
-#define WL_WSEC(args)		do {if (wl_msg_level & WL_WSEC_VAL) printf args;} while (0)
-#define	WL_INFORM(args)		do {if (wl_msg_level & WL_INFORM_VAL) printf args;} while (0)
-#define WL_APSTA_UPDN(args) do {if (wl_apsta_dbg & WL_APSTA_UPDN_VAL) {WL_APSTA(args);}} while (0)
-#define WL_APSTA_RX(args) do {if (wl_apsta_dbg & WL_APSTA_RX_VAL) {WL_APSTA(args);}} while (0)
+extern uint32 wl_msg_level;
+extern uint32 wl_msg_level2;
+
+#define WL_PRINT(args)		printf args
+
+#ifdef BCMDBG
+
+#define	WL_NONE(args)		do {if (wl_msg_level & 0) WL_PRINT(args);} while (0)
+
+#define	WL_ERROR(args)		do {if (wl_msg_level & WL_ERROR_VAL) WL_PRINT(args);} while (0)
+#define	WL_TRACE(args)		do {if (wl_msg_level & WL_TRACE_VAL) WL_PRINT(args);} while (0)
 
 #else	
 
+#define WL_NONE(args)
+
 #ifdef BCMDBG_ERR
-#define	WL_ERROR(args)		printf args
+#define	WL_ERROR(args)		WL_PRINT(args)
 #else
 #define	WL_ERROR(args)
 #endif 
@@ -50,7 +42,6 @@
 #define WL_APSTA_RX(args)
 #define WL_WSEC(args)
 #define WL_WSEC_DUMP(args)
-#define	WL_INFORM(args)
 
 #endif 
 

=== modified file 'src/src/wl/sys/wl_export.h'
--- src/src/wl/sys/wl_export.h	2009-05-11 16:04:29 +0000
+++ src/src/wl/sys/wl_export.h	2010-02-14 19:58:58 +0000
@@ -2,28 +2,15 @@
  * Required functions exported by the port-specific (os-dependent) driver
  * to common (os-independent) driver code.
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: wl_export.h,v 1.66.4.7 2009/01/21 21:48:41 Exp $
+ * $Id: wl_export.h,v 1.78 2009/04/07 18:54:52 Exp $
  */
 
 #ifndef _wl_export_h_
@@ -31,28 +18,35 @@
 
 struct wl_info;
 struct wl_if;
+struct wlc_if;
 extern void wl_init(struct wl_info *wl);
 extern uint wl_reset(struct wl_info *wl);
 extern void wl_intrson(struct wl_info *wl);
 extern uint32 wl_intrsoff(struct wl_info *wl);
 extern void wl_intrsrestore(struct wl_info *wl, uint32 macintmask);
 extern void wl_event(struct wl_info *wl, char *ifname, wlc_event_t *e);
+extern void wl_event_sync(struct wl_info *wl, char *ifname, wlc_event_t *e);
 extern int wl_up(struct wl_info *wl);
 extern void wl_down(struct wl_info *wl);
 extern void wl_dump_ver(struct wl_info *wl, struct bcmstrbuf *b);
 extern void wl_txflowcontrol(struct wl_info *wl, bool state, int prio);
 extern bool wl_alloc_dma_resources(struct wl_info *wl, uint dmaddrwidth);
 
+#ifndef LINUX_WLUSER_POSTMOGRIFY_REMOVAL
+
 struct wl_timer;
 extern struct wl_timer *wl_init_timer(struct wl_info *wl, void (*fn)(void* arg), void *arg,
                                       const char *name);
 extern void wl_free_timer(struct wl_info *wl, struct wl_timer *timer);
 extern void wl_add_timer(struct wl_info *wl, struct wl_timer *timer, uint ms, int periodic);
 extern bool wl_del_timer(struct wl_info *wl, struct wl_timer *timer);
+#endif 
 
-struct wl_if;
 extern void wl_sendup(struct wl_info *wl, struct wl_if *wlif, void *p, int numpkt);
 extern char *wl_ifname(struct wl_info *wl, struct wl_if *wlif);
+extern struct wl_if *wl_add_if(struct wl_info *wl, struct wlc_if* wlcif, uint unit,
+	struct ether_addr *remote);
+extern void wl_del_if(struct wl_info *wl, struct wl_if *wlif);
 
 extern void wl_monitor(struct wl_info *wl, wl_rxsts_t *rxsts, void *p);
 extern void wl_set_monitor(struct wl_info *wl, int val);

=== modified file 'src/src/wl/sys/wl_iw.c'
--- src/src/wl/sys/wl_iw.c	2009-05-11 16:04:29 +0000
+++ src/src/wl/sys/wl_iw.c	2010-02-14 19:58:58 +0000
@@ -1,28 +1,15 @@
 /*
  * Linux Wireless Extensions support
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: wl_iw.c,v 1.63.2.25.4.4 2009/04/20 19:22:00 Exp $
+ * $Id: wl_iw.c,v 1.109.2.2.8.8 2010/01/28 03:10:40 Exp $
  */
 
 #define LINUX_PORT
@@ -49,7 +36,7 @@
 extern bool wl_iw_conn_status_str(uint32 event_type, uint32 status,
 	uint32 reason, char* stringBuf, uint buflen);
 
-#define MAX_IOCTL_LEN 600
+#define MAX_WLIW_IOCTL_LEN 1024
 
 #define htod32(i) i
 #define htod16(i) i
@@ -59,6 +46,7 @@
 #define dtohchanspec(i) i
 
 #ifdef CONFIG_WIRELESS_EXT
+
 extern struct iw_statistics *wl_get_wireless_stats(struct net_device *dev);
 #endif 
 
@@ -67,6 +55,12 @@
 #define IW_EVENT_IDX(cmd)	((cmd) - IWEVFIRST)
 #endif 
 
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 29)
+#define IW_DEV_IF(dev)        ((wl_iw_t *)netdev_priv(dev))
+#else
+#define IW_DEV_IF(dev)        ((wl_iw_t *)dev->priv)
+#endif
+
 static void swap_key_from_BE(
 	        wl_wsec_key_t *key
 )
@@ -114,11 +108,13 @@
 	strcpy(ifr.ifr_name, dev->name);
 	ifr.ifr_data = (caddr_t) &ioc;
 
-	dev_open(dev);
-
 	fs = get_fs();
 	set_fs(get_ds());
+#if defined(WL_USE_NETDEV_OPS)
+	ret = dev->netdev_ops->ndo_do_ioctl(dev, &ifr, SIOCDEVPRIVATE);
+#else
 	ret = dev->do_ioctl(dev, &ifr, SIOCDEVPRIVATE);
+#endif
 	set_fs(fs);
 
 	return ret;
@@ -163,17 +159,21 @@
 	char *name,
 	char *buf, int buflen)
 {
-	char ioctlbuf[MAX_IOCTL_LEN];
+	char *ioctlbuf;
 	int error;
 
 	uint len;
 
-	len = bcm_mkiovar(name, NULL, 0, ioctlbuf, sizeof(ioctlbuf));
+	ioctlbuf = kmalloc(MAX_WLIW_IOCTL_LEN, GFP_KERNEL);
+	if (!ioctlbuf)
+		return -ENOMEM;
+	len = bcm_mkiovar(name, NULL, 0, ioctlbuf, MAX_WLIW_IOCTL_LEN);
 	ASSERT(len);
-	error = dev_wlc_ioctl(dev, WLC_GET_VAR, (void *)ioctlbuf, MAX_IOCTL_LEN);
+	error = dev_wlc_ioctl(dev, WLC_GET_VAR, (void *)ioctlbuf, MAX_WLIW_IOCTL_LEN);
 	if (!error)
 		bcopy(ioctlbuf, buf, buflen);
 
+	kfree(ioctlbuf);
 	return (error);
 }
 
@@ -285,7 +285,7 @@
 
 	bzero(&bssid, sizeof(struct sockaddr));
 	if ((error = dev_wlc_ioctl(dev, WLC_REASSOC, &bssid, ETHER_ADDR_LEN))) {
-		WL_ERROR(("Invalid ioctl data.\n"));
+		WL_ERROR(("%s: WLC_REASSOC failed (%d)\n", __FUNCTION__, error));
 		return error;
 	}
 
@@ -467,7 +467,7 @@
 )
 {
 	struct iw_range *range = (struct iw_range *) extra;
-	int channels[MAXCHANNEL+1];
+	static int channels[MAXCHANNEL+1];
 	wl_uint32_list_t *list = (wl_uint32_list_t *) channels;
 	wl_rateset_t rateset;
 	int error, i;
@@ -580,6 +580,10 @@
 	range->enc_capa |= IW_ENC_CAPA_CIPHER_TKIP;
 	range->enc_capa |= IW_ENC_CAPA_CIPHER_CCMP;
 	range->enc_capa |= IW_ENC_CAPA_WPA2;
+#if WIRELESS_EXT >= 22 && defined(IW_SCAN_CAPA_ESSID)
+
+	range->scan_capa = IW_SCAN_CAPA_ESSID;
+#endif
 #endif 
 
 	return 0;
@@ -610,7 +614,7 @@
 	char *extra
 )
 {
-	wl_iw_t *iw = dev->priv;
+	wl_iw_t *iw = IW_DEV_IF(dev);
 	struct sockaddr *addr = (struct sockaddr *) extra;
 	int i;
 
@@ -635,7 +639,7 @@
 	char *extra
 )
 {
-	wl_iw_t *iw = dev->priv;
+	wl_iw_t *iw = IW_DEV_IF(dev);
 	struct sockaddr *addr = (struct sockaddr *) extra;
 	struct iw_quality *qual = (struct iw_quality *) &addr[iw->spy_num];
 	int i;
@@ -672,20 +676,21 @@
 	WL_TRACE(("%s: SIOCSIWAP\n", dev->name));
 
 	if (awrq->sa_family != ARPHRD_ETHER) {
-		WL_ERROR(("Invalid Header...sa_family\n"));
+		WL_ERROR(("%s: Invalid Header...sa_family\n", __FUNCTION__));
 		return -EINVAL;
 	}
 
 	if (ETHER_ISBCAST(awrq->sa_data) || ETHER_ISNULLADDR(awrq->sa_data)) {
 		scb_val_t scbval;
-
 		bzero(&scbval, sizeof(scb_val_t));
-		dev_wlc_ioctl(dev, WLC_DISASSOC, &scbval, sizeof(scb_val_t));
+		if ((error = dev_wlc_ioctl(dev, WLC_DISASSOC, &scbval, sizeof(scb_val_t)))) {
+			WL_ERROR(("%s: WLC_DISASSOC failed (%d).\n", __FUNCTION__, error));
+		}
 		return 0;
 	}
 
 	if ((error = dev_wlc_ioctl(dev, WLC_REASSOC, awrq->sa_data, ETHER_ADDR_LEN))) {
-		WL_ERROR(("Invalid ioctl data.\n"));
+		WL_ERROR(("%s: WLC_REASSOC failed (%d).\n", __FUNCTION__, error));
 		return error;
 	}
 
@@ -744,7 +749,7 @@
 			sizeof(scb_val_t));
 	}
 	else {
-		WL_ERROR(("Invalid ioctl data.\n"));
+		WL_ERROR(("%s: Invalid ioctl data.\n", __FUNCTION__));
 		return error;
 	}
 
@@ -1039,6 +1044,7 @@
 
 	return 0;
 }
+
 #endif 
 
 static int
@@ -1064,6 +1070,7 @@
 		memcpy(ssid.SSID, extra, ssid.SSID_len);
 		ssid.SSID_len = htod32(ssid.SSID_len);
 	}
+
 	if ((error = dev_wlc_ioctl(dev, WLC_SET_SSID, &ssid, sizeof(ssid))))
 		return error;
 
@@ -1110,8 +1117,7 @@
 	char *extra
 )
 {
-	wl_iw_t *iw = dev->priv;
-
+	wl_iw_t *iw = IW_DEV_IF(dev);
 	WL_TRACE(("%s: SIOCSIWNICKN\n", dev->name));
 
 	if (!extra)
@@ -1134,8 +1140,7 @@
 	char *extra
 )
 {
-	wl_iw_t *iw = dev->priv;
-
+	wl_iw_t *iw = IW_DEV_IF(dev);
 	WL_TRACE(("%s: SIOCGIWNICKN\n", dev->name));
 
 	if (!extra)
@@ -1566,8 +1571,7 @@
 	if (key.index >= DOT11_MAX_DEFAULT_KEYS)
 		key.index = 0;
 
-	if ((error = dev_wlc_ioctl(dev, WLC_GET_KEY, &key, sizeof(key))) ||
-	    (error = dev_wlc_ioctl(dev, WLC_GET_WSEC, &wsec, sizeof(wsec))) ||
+	if ((error = dev_wlc_ioctl(dev, WLC_GET_WSEC, &wsec, sizeof(wsec))) ||
 	    (error = dev_wlc_ioctl(dev, WLC_GET_AUTH, &auth, sizeof(auth))))
 		return error;
 
@@ -1790,7 +1794,7 @@
 	int paramid;
 	int paramval;
 	int val = 0;
-	wl_iw_t *iw = dev->priv;
+	wl_iw_t *iw = IW_DEV_IF(dev);
 
 	WL_TRACE(("%s: SIOCSIWAUTH\n", dev->name));
 
@@ -1799,6 +1803,12 @@
 
 	switch (paramid) {
 	case IW_AUTH_WPA_VERSION:
+		if ((error = dev_wlc_intvar_get(dev, "wsec", &val)))
+			return error;
+		if (val & (TKIP_ENABLED | AES_ENABLED)) {
+			val &= ~(TKIP_ENABLED | AES_ENABLED);
+			dev_wlc_intvar_set(dev, "wsec", val);
+		}
 
 		if (paramval & IW_AUTH_WPA_VERSION_DISABLED)
 			val = WPA_AUTH_DISABLED;
@@ -1921,7 +1931,7 @@
 	int paramid;
 	int paramval = 0;
 	int val;
-	wl_iw_t *iw = dev->priv;
+	wl_iw_t *iw = IW_DEV_IF(dev);
 
 	WL_TRACE(("%s: SIOCGIWAUTH\n", dev->name));
 
@@ -2128,7 +2138,7 @@
 	.private_args = wl_iw_priv_args,
 #if WIRELESS_EXT >= 19
 	get_wireless_stats: wl_get_wireless_stats,
-#endif
+#endif 
 	};
 #endif 
 
@@ -2289,7 +2299,7 @@
 		memset(stringBuf, 0, buflen);
 		snprintf(stringBuf, buflen, "%s %s %02d %02d",
 			name, cause, status, reason);
-		WL_INFORM(("Connection status: %s\n", stringBuf));
+		WL_TRACE(("Connection status: %s\n", stringBuf));
 		return TRUE;
 	} else {
 		return FALSE;
@@ -2327,6 +2337,8 @@
 	int cmd = 0;
 	uint32 event_type = e->event_type;
 	uint16 flags =  e->flags;
+	uint32 datalen = e->datalen;
+	uint32 status =  e->status;
 
 	memset(&wrqu, 0, sizeof(wrqu));
 	memset(extra, 0, sizeof(extra));
@@ -2360,6 +2372,25 @@
 			bzero(&extra, ETHER_ADDR_LEN);
 		}
 		break;
+	case WLC_E_ACTION_FRAME:
+		cmd = IWEVCUSTOM;
+		if (datalen + 1 <= sizeof(extra)) {
+			wrqu.data.length = datalen + 1;
+			extra[0] = WLC_E_ACTION_FRAME;
+			memcpy(&extra[1], data, datalen);
+			WL_TRACE(("WLC_E_ACTION_FRAME len %d \n", wrqu.data.length));
+		}
+		break;
+
+	case WLC_E_ACTION_FRAME_COMPLETE:
+		cmd = IWEVCUSTOM;
+		if (sizeof(status) + 1 <= sizeof(extra)) {
+			wrqu.data.length = sizeof(status) + 1;
+			extra[0] = WLC_E_ACTION_FRAME_COMPLETE;
+			memcpy(&extra[1], &status, sizeof(status));
+			WL_TRACE(("wl_iw_event status %d  \n", status));
+		}
+		break;
 #endif 
 #if WIRELESS_EXT > 17
 	case WLC_E_MIC_ERROR: {
@@ -2402,6 +2433,7 @@
 		return;
 	}
 #endif 
+
 	default:
 
 		break;
@@ -2504,3 +2536,12 @@
 done:
 	return res;
 }
+
+int wl_iw_attach(struct net_device *dev)
+{
+	return 0;
+}
+
+void wl_iw_detach(void)
+{
+}

=== modified file 'src/src/wl/sys/wl_iw.h'
--- src/src/wl/sys/wl_iw.h	2009-05-11 16:04:29 +0000
+++ src/src/wl/sys/wl_iw.h	2010-02-14 19:58:58 +0000
@@ -1,28 +1,15 @@
 /*
  * Linux Wireless Extensions support
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: wl_iw.h,v 1.5.32.7 2009/03/02 21:54:59 Exp $
+ * $Id: wl_iw.h,v 1.15 2009/04/17 00:19:28 Exp $
  */
 
 #ifndef _wl_iw_h_
@@ -42,6 +29,20 @@
 #define	WL_IW_RSSI_VERY_GOOD	-58	
 #define	WL_IW_RSSI_EXCELLENT	-57	
 #define	WL_IW_RSSI_INVALID	 0	
+#define MAX_WX_STRING 80
+#define isprint(c) bcm_isprint(c)
+#define WL_IW_SET_ACTIVE_SCAN	(SIOCIWFIRSTPRIV+1)
+#define WL_IW_GET_RSSI			(SIOCIWFIRSTPRIV+3)
+#define WL_IW_SET_PASSIVE_SCAN	(SIOCIWFIRSTPRIV+5)
+#define WL_IW_GET_LINK_SPEED	(SIOCIWFIRSTPRIV+7)
+#define WL_IW_GET_CURR_MACADDR	(SIOCIWFIRSTPRIV+9)
+#define WL_IW_SET_STOP				(SIOCIWFIRSTPRIV+11)
+#define WL_IW_SET_START			(SIOCIWFIRSTPRIV+13)
+
+#define 		G_SCAN_RESULTS 8*1024
+#define 		WE_ADD_EVENT_FIX	0x80
+#define          G_WLAN_SET_ON	0
+#define          G_WLAN_SET_OFF	1
 
 typedef struct wl_iw {
 	char nickname[IW_ESSID_MAX_SIZE];
@@ -57,6 +58,14 @@
 	void  *wlinfo;
 } wl_iw_t;
 
+struct wl_ctrl {
+	struct timer_list *timer;
+	struct net_device *dev;
+	long sysioc_pid;
+	struct semaphore sysioc_sem;
+	struct completion sysioc_exited;
+};
+
 #if WIRELESS_EXT > 12
 #include <net/iw_handler.h>
 extern const struct iw_handler_def wl_iw_handler_def;
@@ -65,6 +74,8 @@
 extern int wl_iw_ioctl(struct net_device *dev, struct ifreq *rq, int cmd);
 extern void wl_iw_event(struct net_device *dev, wl_event_msg_t *e, void* data);
 extern int wl_iw_get_wireless_stats(struct net_device *dev, struct iw_statistics *wstats);
+int wl_iw_attach(struct net_device *dev);
+void wl_iw_detach(void);
 
 #if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 27)
 #define IWE_STREAM_ADD_EVENT(info, stream, ends, iwe, extra) \

=== modified file 'src/src/wl/sys/wl_linux.c'
--- src/src/wl/sys/wl_linux.c	2009-05-11 16:04:29 +0000
+++ src/src/wl/sys/wl_linux.c	2010-02-14 19:58:58 +0000
@@ -2,28 +2,15 @@
  * Linux-specific portion of
  * Broadcom 802.11abg Networking Device Driver
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: wl_linux.c,v 1.388.2.78.4.2 2009/04/03 02:06:22 Exp $
+ * $Id: wl_linux.c,v 1.480.2.12.2.14 2009/12/31 19:03:02 Exp $
  */
 
 #define LINUX_PORT
@@ -52,11 +39,9 @@
 #include <linux/completion.h>
 #include <linux/pci_ids.h>
 #define WLC_MAXBSSCFG		1	
-
-#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 14)
-#include <net/ieee80211.h>
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 32)
+#include <linux/sched.h>
 #endif
-
 #include <asm/system.h>
 #include <asm/io.h>
 #include <asm/irq.h>
@@ -74,14 +59,15 @@
 #include <wlioctl.h>
 #include <wlc_key.h>
 
+typedef const struct si_pub	si_t;
+
+typedef void wlc_info_t;
+typedef void wlc_hw_info_t;
+
 #if LINUX_VERSION_CODE <= KERNEL_VERSION(2, 4, 5)
 #error "No support for Kernel Rev <= 2.4.5, As the older kernel revs doesn't support Tasklets"
 #endif
 
-typedef void wlc_info_t;
-typedef void wlc_hw_info_t;
-typedef const struct si_pub	si_t;
-
 #include <wlc_pub.h>
 #include <wl_dbg.h>
 
@@ -130,19 +116,12 @@
 	u8 rx_hdr[16], tx_hdr[16];
 };
 
-#define	WL_DEV_IF(dev)		((wl_if_t*)(dev)->priv)			
 #define	WL_INFO(dev)		((wl_info_t*)(WL_DEV_IF(dev)->wl))	
 
-#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 20)
-#define	WL_ISR(i, d, p)		wl_isr((i), (d))
-#else
-#define	WL_ISR(i, d, p)		wl_isr((i), (d), (p))
-#endif	
-
 static int wl_open(struct net_device *dev);
 static int wl_close(struct net_device *dev);
 static int wl_start(struct sk_buff *skb, struct net_device *dev);
-static int wl_start_int(wl_if_t *wlif, struct sk_buff *skb);
+static int wl_start_int(wl_info_t *wl, wl_if_t *wlif, struct sk_buff *skb);
 
 static struct net_device_stats *wl_get_stats(struct net_device *dev);
 static int wl_set_mac_address(struct net_device *dev, void *addr);
@@ -150,19 +129,28 @@
 static void _wl_set_multicast_list(struct net_device *dev);
 static int wl_ethtool(wl_info_t *wl, void *uaddr, wl_if_t *wlif);
 static void wl_dpc(ulong data);
-static void wl_link_up(wl_info_t *wl);
-static void wl_link_down(wl_info_t *wl);
-static void wl_mic_error(wl_info_t *wl, struct ether_addr *ea, bool group, bool flush_txq);
+static void wl_link_up(wl_info_t *wl, char * ifname);
+static void wl_link_down(wl_info_t *wl, char *ifname);
+#if defined(WL_CONFIG_RFKILL_INPUT)
+static int wl_schedule_task(wl_info_t *wl, void (*fn)(struct wl_task *), void *context);
+#endif
 #if defined(CONFIG_PROC_FS)
 static int wl_read_proc(char *buffer, char **start, off_t offset, int length, int *eof, void *data);
 #endif 
 #if defined(BCMDBG)
 static int wl_dump(wl_info_t *wl, struct bcmstrbuf *b);
 #endif 
-struct wl_if *wl_alloc_if(wl_info_t *wl, int iftype, uint unit, struct wlc_if* wlc_if);
+static struct wl_if *wl_alloc_if(wl_info_t *wl, int iftype, uint unit, struct wlc_if* wlc_if);
 static void wl_free_if(wl_info_t *wl, wl_if_t *wlif);
 static void wl_get_driver_info(struct net_device *dev, struct ethtool_drvinfo *info);
 
+#if defined(WL_CONFIG_RFKILL_INPUT)
+#include <linux/rfkill.h>
+static int wl_init_rfkill(wl_info_t *wl);
+static void wl_uninit_rfkill(wl_info_t *wl);
+static void wl_force_kill(wl_task_t *task);
+#endif
+
 static struct pci_device_id wl_id_table[] = {
 	{ PCI_VENDOR_ID_BROADCOM, 0x4311, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, 
 	{ PCI_VENDOR_ID_BROADCOM, 0x4312, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, 
@@ -176,6 +164,7 @@
 	{ PCI_VENDOR_ID_BROADCOM, 0x432d, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, 
 	{ PCI_VENDOR_ID_BROADCOM, 0x4353, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, 
 	{ PCI_VENDOR_ID_BROADCOM, 0x4357, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, 
+	{ PCI_VENDOR_ID_BROADCOM, 0x4727, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 }, 
 	{ 0 }
 };
 MODULE_DEVICE_TABLE(pci, wl_id_table);
@@ -193,6 +182,9 @@
 static int piomode = 0;
 module_param(piomode, int, 0);
 
+static int instance_base = 0;	
+module_param(instance_base, int, 0);
+
 static int nompc = 0;
 module_param(nompc, int, 0);
 
@@ -214,9 +206,25 @@
 };
 #endif 
 
+#if defined(WL_USE_NETDEV_OPS)
+static const struct net_device_ops wl_netdev_ops =
+{
+	.ndo_open = wl_open,
+	.ndo_stop = wl_close,
+	.ndo_start_xmit = wl_start,
+	.ndo_get_stats = wl_get_stats,
+	.ndo_set_mac_address = wl_set_mac_address,
+	.ndo_set_multicast_list = wl_set_multicast_list,
+	.ndo_do_ioctl = wl_ioctl
+};
+#endif 
+
 static
 void wl_if_setup(struct net_device *dev)
 {
+#if defined(WL_USE_NETDEV_OPS)
+	dev->netdev_ops = &wl_netdev_ops;
+#else
 	dev->open = wl_open;
 	dev->stop = wl_close;
 	dev->hard_start_xmit = wl_start;
@@ -224,6 +232,8 @@
 	dev->set_mac_address = wl_set_mac_address;
 	dev->set_multicast_list = wl_set_multicast_list;
 	dev->do_ioctl = wl_ioctl;
+#endif 
+
 #ifdef CONFIG_WIRELESS_EXT
 #if WIRELESS_EXT < 19
 	dev->get_wireless_stats = wl_get_wireless_stats;
@@ -236,6 +246,7 @@
 #endif 
 
 #endif 
+
 }
 
 static wl_info_t *
@@ -250,9 +261,14 @@
 	osl_t *osh;
 	int unit;
 
-	unit = wl_found;
-
-	if (oneonly && (unit != 0)) {
+	unit = wl_found + instance_base;
+
+	if (unit < 0) {
+		WL_ERROR(("wl%d: unit number overflow, exiting\n", unit));
+		return NULL;
+	}
+
+	if (oneonly && (unit != instance_base)) {
 		WL_ERROR(("wl%d: wl_attach: oneonly is set, exiting\n", unit));
 		return NULL;
 	}
@@ -283,6 +299,10 @@
 	wl->dev = dev;
 	wl_if_setup(dev);
 
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 29)
+	wlif = netdev_priv(dev);
+#endif
+
 	dev->base_addr = regs;
 
 	WL_TRACE(("wl%d: Bus: ", unit));
@@ -301,7 +321,7 @@
 		bustype = PCI_BUS;
 		WL_TRACE(("force to PCI\n"));
 	}
-	wl->bustype = bustype;
+	wl->bcm_bustype = bustype;
 
 	if ((wl->regsva = ioremap_nocache(dev->base_addr, PCI_BAR0_WINSZ)) == NULL) {
 		WL_ERROR(("wl%d: ioremap() failed\n", unit));
@@ -314,12 +334,12 @@
 	{
 	int err;
 	if (!(wl->wlc = wlc_attach((void *) wl, vendor, device, unit, wl->piomode,
-		osh, wl->regsva, wl->bustype, btparam, &err))) {
+		osh, wl->regsva, wl->bcm_bustype, btparam, &err))) {
 		printf("%s: %s driver failed with code %d\n", dev->name, EPI_VERSION_STR, err);
 		goto fail;
 	}
 	}
-	wl->pub = (wlc_pub_t *)wl->wlc;
+	wl->pub = wlc_pub(wl->wlc);
 
 	if (nompc) {
 		if (wlc_iovar_setint(wl->wlc, "mpc", 0)) {
@@ -327,6 +347,10 @@
 		}
 	}
 
+	wlc_iovar_setint(wl->wlc, "scan_passive_time", 170);
+
+	wlc_iovar_setint(wl->wlc, "qtxpower", 23 * 4);
+
 #if defined(CONFIG_PROC_FS)
 
 	sprintf(tmp, "net/wl%d", wl->pub->unit);
@@ -345,7 +369,7 @@
 		dev->irq = irq;
 	}
 
-	if (wl->bustype == PCI_BUS) {
+	if (wl->bcm_bustype == PCI_BUS) {
 		struct pci_dev *pci_dev = (struct pci_dev *)btparam;
 		if (pci_dev != NULL)
 			SET_NETDEV_DEV(dev, &pci_dev->dev);
@@ -359,16 +383,29 @@
 
 #if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 14)
 
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 29)
+	wl->tkipmodops = lib80211_get_crypto_ops("TKIP");
+	if (wl->tkipmodops == NULL) {
+		request_module("lib80211_crypt_tkip");
+		wl->tkipmodops = lib80211_get_crypto_ops("TKIP");
+	}
+#else
 	wl->tkipmodops = ieee80211_get_crypto_ops("TKIP");
 	if (wl->tkipmodops == NULL) {
 		request_module("ieee80211_crypt_tkip");
 		wl->tkipmodops = ieee80211_get_crypto_ops("TKIP");
 	}
 #endif 
+#endif 
 #ifdef CONFIG_WIRELESS_EXT
 	wlif->iw.wlinfo = (void *)wl;
 #endif
 
+#if defined(WL_CONFIG_RFKILL_INPUT)
+	if (wl_init_rfkill(wl) < 0)
+		WL_ERROR(("%s: init_rfkill_failure\n", __FUNCTION__));
+#endif
+
 	if (wlc_iovar_setint(wl->wlc, "leddc", 0xa0000)) {
 		WL_ERROR(("wl%d: Error setting led duty-cycle\n", unit));
 	}
@@ -390,7 +427,7 @@
 	wlc_dump_register(wl->pub, "wl", (dump_fn_t)wl_dump, (void *)wl);
 #endif
 
-	printf("%s: Broadcom BCM%04x 802.11 Wireless Controller " EPI_VERSION_STR,
+	printf("%s: Broadcom BCM%04x 802.11 Hybrid Wireless Controller " EPI_VERSION_STR,
 		dev->name, device);
 
 #ifdef BCMDBG
@@ -563,6 +600,7 @@
 	WL_APSTA_UPDN(("wl%d (%s): wl_remove() -> wl_down()\n", wl->pub->unit, wl->dev->name));
 	wl_down(wl);
 	WL_UNLOCK(wl);
+
 	wl_free(wl);
 	pci_disable_device(pdev);
 	pci_set_drvdata(pdev, NULL);
@@ -630,6 +668,10 @@
 			free_irq(wl->dev->irq, wl);
 	}
 
+#if defined(WL_CONFIG_RFKILL_INPUT)
+	wl_uninit_rfkill(wl);
+#endif
+
 	if (wl->dev) {
 		wl_free_if(wl, WL_DEV_IF(wl->dev));
 		wl->dev = NULL;
@@ -666,14 +708,14 @@
 	}
 
 	if (wl->monitor) {
-		wl_free_if(wl, (wl_if_t *)(wl->monitor->priv));
+		wl_free_if(wl, WL_DEV_IF(wl->monitor));
 		wl->monitor = NULL;
 	}
 
 	osh = wl->osh;
 
-	if (wl->regsva && BUSTYPE(wl->bustype) != SDIO_BUS &&
-	    BUSTYPE(wl->bustype) != JTAG_BUS) {
+	if (wl->regsva && BUSTYPE(wl->bcm_bustype) != SDIO_BUS &&
+	    BUSTYPE(wl->bcm_bustype) != JTAG_BUS) {
 		iounmap((void*)wl->regsva);
 	}
 	wl->regsva = NULL;
@@ -681,13 +723,16 @@
 #if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 14)
 
 	if (wl->tkipmodops != NULL) {
+		int idx;
 		if (wl->tkip_ucast_data) {
 			wl->tkipmodops->deinit(wl->tkip_ucast_data);
 			wl->tkip_ucast_data = NULL;
 		}
-		if (wl->tkip_bcast_data) {
-			wl->tkipmodops->deinit(wl->tkip_bcast_data);
-			wl->tkip_bcast_data = NULL;
+		for (idx = 0; idx < NUM_GROUP_KEYS; idx++) {
+			if (wl->tkip_bcast_data[idx]) {
+				wl->tkipmodops->deinit(wl->tkip_bcast_data[idx]);
+				wl->tkip_bcast_data[idx] = NULL;
+			}
 		}
 	}
 #endif 
@@ -757,40 +802,36 @@
 static int BCMFASTPATH
 wl_start(struct sk_buff *skb, struct net_device *dev)
 {
-	wl_if_t *wlif;
-
 	if (!dev)
 		return -ENETDOWN;
 
-	wlif = WL_DEV_IF(dev);
-
-	return wl_start_int(wlif, skb);
+	return wl_start_int(WL_INFO(dev), WL_DEV_IF(dev), skb);
 }
 
 static int BCMFASTPATH
-wl_start_int(wl_if_t *wlif, struct sk_buff *skb)
+wl_start_int(wl_info_t *wl, wl_if_t *wlif, struct sk_buff *skb)
 {
-	wl_info_t *wl;
 	void *pkt;
 
-	wl = wlif->wl;
-
-	WL_LOCK(wl);
-
 	WL_TRACE(("wl%d: wl_start: len %d summed %d\n", wl->pub->unit, skb->len, skb->ip_summed));
 
+	WL_LOCK(wl);
+
 	if ((pkt = PKTFRMNATIVE(wl->osh, skb)) == NULL) {
 		WL_ERROR(("wl%d: PKTFRMNATIVE failed!\n", wl->pub->unit));
-		WLCNTINCR(wl->pub->_cnt.txnobuf);
-		dev_kfree_skb_any(skb);
+		WLCNTINCR(wl->pub->_cnt->txnobuf);
+		PKTFREE(wl->osh, skb, TRUE);
 		WL_UNLOCK(wl);
 		return 0;
 	}
 
 	if (WME_ENAB(wl->pub) && (PKTPRIO(pkt) == 0))
 		pktsetprio(pkt, FALSE);
+
 	wlc_sendpkt(wl->wlc, pkt, wlif->wlcif);
+
 	WL_UNLOCK(wl);
+
 	return (0);
 }
 
@@ -808,19 +849,51 @@
 	}
 }
 
-struct wl_if *
+#if defined(WL_CONFIG_RFKILL_INPUT)
+
+static int
+wl_schedule_task(wl_info_t *wl, void (*fn)(struct wl_task *task), void *context)
+{
+	wl_task_t *task;
+
+	WL_TRACE(("wl%d: wl_schedule_task\n", wl->pub->unit));
+
+	if (!(task = MALLOC(wl->osh, sizeof(wl_task_t)))) {
+		WL_ERROR(("wl%d: wl_schedule_task: out of memory, malloced %d bytes\n",
+			wl->pub->unit, MALLOCED(wl->osh)));
+		return -ENOMEM;
+	}
+
+	MY_INIT_WORK(&task->work, (work_func_t)fn);
+	task->context = context;
+
+	if (!schedule_work(&task->work)) {
+		WL_ERROR(("wl%d: schedule_work() failed\n", wl->pub->unit));
+		MFREE(wl->osh, task, sizeof(wl_task_t));
+		return -ENOMEM;
+	}
+
+	atomic_inc(&wl->callbacks);
+
+	return 0;
+}
+#endif 
+
+static struct wl_if *
 wl_alloc_if(wl_info_t *wl, int iftype, uint subunit, struct wlc_if* wlcif)
 {
 	struct net_device *dev;
 	wl_if_t *wlif;
 	wl_if_t *p;
 
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 29))
 	if (!(wlif = MALLOC(wl->osh, sizeof(wl_if_t)))) {
 		WL_ERROR(("wl%d: wl_alloc_if: out of memory, malloced %d bytes\n",
 		          (wl->pub)?wl->pub->unit:subunit, MALLOCED(wl->osh)));
 		return NULL;
 	}
 	bzero(wlif, sizeof(wl_if_t));
+#endif 
 #if (LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 24))
 	if (!(dev = MALLOC(wl->osh, sizeof(struct net_device)))) {
 		MFREE(wl->osh, wlif, sizeof(wl_if_t));
@@ -832,22 +905,29 @@
 	ether_setup(dev);
 	strncpy(dev->name, name, IFNAMSIZ);
 #else
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 29)
 
-	dev = alloc_netdev(0, name, ether_setup);
+	dev = alloc_netdev(sizeof(wl_if_t), name, ether_setup);
+	wlif = netdev_priv(dev);
 	if (!dev) {
-		MFREE(wl->osh, wlif, sizeof(wl_if_t));
-		WL_ERROR(("wl%d: wl_alloc_if: out of memory, alloc_netdev\n",
-			(wl->pub)?wl->pub->unit:subunit));
-		return NULL;
+#else
+		dev = alloc_netdev(0, name, ether_setup);
+		if (!dev) {
+			MFREE(wl->osh, wlif, sizeof(wl_if_t));
+#endif
+			WL_ERROR(("wl%d: wl_alloc_if: out of memory, alloc_netdev\n",
+				(wl->pub)?wl->pub->unit:subunit));
+			return NULL;
 	}
 #endif 
 
-	wlif->type = iftype;
 	wlif->dev = dev;
 	wlif->wl = wl;
 	wlif->wlcif = wlcif;
 	wlif->subunit = subunit;
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 29)
 	dev->priv = wlif;
+#endif
 
 	if (iftype != WL_IFTYPE_MON && wl->dev && netif_queue_stopped(wl->dev))
 		netif_stop_queue(dev);
@@ -886,7 +966,10 @@
 		MFREE(wl->osh, wlif->dev, sizeof(struct net_device));
 #else
 		free_netdev(wlif->dev);
-#endif
+#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 29))
+		return;
+#endif	
+#endif	
 	}
 	MFREE(wl->osh, wlif, sizeof(wl_if_t));
 }
@@ -987,7 +1070,6 @@
 	WL_TRACE(("wl%d: wl_down\n", wl->pub->unit));
 
 	for (wlif = wl->if_list; wlif != NULL; wlif = wlif->next) {
-		WL_INFORM(("%s: stop interfaces\n", __FUNCTION__));
 		netif_down(wlif->dev);
 		netif_stop_queue(wlif->dev);
 	}
@@ -998,7 +1080,6 @@
 	WL_UNLOCK(wl);
 
 	SPINWAIT((atomic_read(&wl->callbacks) > callbacks), 100 * 1000);
-	ASSERT(atomic_read(&wl->callbacks) == callbacks);
 
 	WL_LOCK(wl);
 }
@@ -1042,12 +1123,18 @@
 	uint32 toe_cmpnt = 0, csum_dir;
 	int ret;
 
+	if (!wl || !wl->pub || !wl->wlc)
+		return -ENODEV;
+
 	WL_TRACE(("wl%d: %s\n", wl->pub->unit, __FUNCTION__));
 	if (copy_from_user(&cmd, uaddr, sizeof(uint32)))
 		return (-EFAULT);
 
 	switch (cmd) {
 	case ETHTOOL_GDRVINFO:
+		if (!wl->dev)
+			return -ENETDOWN;
+
 		wl_get_driver_info(wl->dev, &info);
 		info.cmd = cmd;
 		if (copy_to_user(uaddr, &info, sizeof(info)))
@@ -1087,6 +1174,8 @@
 			return ret;
 
 		if (cmd == ETHTOOL_STXCSUM) {
+			if (!wl->dev)
+				return -ENETDOWN;
 			if (edata.data)
 				wl->dev->features |= NETIF_F_IP_CSUM;
 			else
@@ -1257,7 +1346,7 @@
 		rssi = 0;
 	else {
 		scb_val_t scb;
-		res = wlc_ioctl(wl->wlc, WLC_GET_RSSI, &scb, sizeof(scb), wlif->wlcif);
+		res = wlc_ioctl(wl->wlc, WLC_GET_RSSI, &scb, sizeof(int), wlif->wlcif);
 		if (res) {
 			WL_ERROR(("wl%d: %s: WLC_GET_RSSI failed (%d)\n",
 				wl->pub->unit, __FUNCTION__, res));
@@ -1445,7 +1534,7 @@
 		skb->dev = wl->dev;
 	}
 
-	skb->protocol = eth_type_trans(skb, skb->dev);
+	skb->protocol = eth_type_trans(skb, wl->dev);
 	if (!ISALIGNED((uintptr)skb->data, 4)) {
 		WL_ERROR(("Unaligned assert. skb %p. skb->data %p.\n", skb, skb->data));
 		if (wlif) {
@@ -1503,15 +1592,15 @@
 #endif	
 
 static void
-wl_link_up(wl_info_t *wl)
+wl_link_up(wl_info_t *wl, char *ifname)
 {
-	WL_ERROR(("wl%d: %s: link up\n", wl->pub->unit, __FUNCTION__));
+	WL_ERROR(("wl%d: link up (%s)\n", wl->pub->unit, ifname));
 }
 
 static void
-wl_link_down(wl_info_t *wl)
+wl_link_down(wl_info_t *wl, char *ifname)
 {
-	WL_ERROR(("wl%d: %s: link down\n", wl->pub->unit, __FUNCTION__));
+	WL_ERROR(("wl%d: link down (%s)\n", wl->pub->unit, ifname));
 }
 
 void
@@ -1525,16 +1614,34 @@
 	case WLC_E_LINK:
 	case WLC_E_NDIS_LINK:
 		if (e->event.flags&WLC_EVENT_MSG_LINK)
-			wl_link_up(wl);
+			wl_link_up(wl, ifname);
 		else
-			wl_link_down(wl);
-		break;
-	case WLC_E_MIC_ERROR:
-		wl_mic_error(wl, e->addr,
-			e->event.flags&WLC_EVENT_MSG_GROUP,
-			e->event.flags&WLC_EVENT_MSG_FLUSHTXQ);
-		break;
-	}
+			wl_link_down(wl, ifname);
+		break;
+#if defined(WL_CONFIG_RFKILL_INPUT)
+	case WLC_E_RADIO: {
+		mbool i;
+		if (wlc_get(wl->wlc, WLC_GET_RADIO, &i) < 0)
+			WL_ERROR(("%s: WLC_GET_RADIO failed\n", __FUNCTION__));
+		if (wl->last_phyind == (mbool)(i & WL_RADIO_HW_DISABLE))
+			break;
+
+		wl->last_phyind = (mbool)(i & WL_RADIO_HW_DISABLE);
+
+		WL_ERROR(("wl%d: Radio hardware state changed to %d\n", wl->pub->unit, i));
+		(void) wl_schedule_task(wl, wl_force_kill, wl);
+		break;
+	}
+#else
+	case WLC_E_RADIO:
+		break;
+#endif 
+	}
+}
+
+void
+wl_event_sync(wl_info_t *wl, char *ifname, wlc_event_t *e)
+{
 }
 
 static void
@@ -1598,6 +1705,12 @@
 void
 wl_add_timer(wl_info_t *wl, wl_timer_t *t, uint ms, int periodic)
 {
+#ifdef BCMDBG
+	if (t->set) {
+		WL_ERROR(("%s: Already set. Name: %s, per %d\n",
+			__FUNCTION__, t->name, periodic));
+	}
+#endif
 	ASSERT(!t->set);
 
 	t->ms = ms;
@@ -1660,14 +1773,6 @@
 
 }
 
-static void
-wl_mic_error(wl_info_t *wl, struct ether_addr *ea, bool group, bool flush_txq)
-{
-	WL_WSEC(("wl%d: mic error using %s key\n", wl->pub->unit,
-		(group) ? "group" : "pairwise"));
-
-}
-
 void
 wl_monitor(wl_info_t *wl, wl_rxsts_t *rxsts, void *p)
 {
@@ -1722,9 +1827,9 @@
 	skb->dev = wl->dev;
 
 	if (wl->tkipmodops) {
-		if (group_key && wl->tkip_bcast_data)
+		if (group_key && wl->tkip_bcast_data[key_index])
 			return (wl->tkipmodops->decrypt_msdu(skb, key_index, hdr_len,
-				wl->tkip_bcast_data));
+				wl->tkip_bcast_data[key_index]));
 		else if (!group_key && wl->tkip_ucast_data)
 			return (wl->tkipmodops->decrypt_msdu(skb, key_index, hdr_len,
 				wl->tkip_ucast_data));
@@ -1783,11 +1888,22 @@
 	int err = -1;
 #if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 14)
 	struct sk_buff *skb = (struct sk_buff *)p;
-	skb->dev = wl->dev;
+	uint8 *pos;
+	uint8 key_idx = 0;
+
+	if (group_key) {
+		skb->dev = wl->dev;
+		pos = skb->data + hdr_len;
+		key_idx = pos[3];
+		key_idx >>= 6;
+		WL_ERROR(("%s: Invalid key_idx %d\n", __FUNCTION__, key_idx));
+		ASSERT(key_idx < NUM_GROUP_KEYS);
+	}
 
 	if (wl->tkipmodops) {
-		if (group_key && wl->tkip_bcast_data)
-			err = wl->tkipmodops->decrypt_mpdu(skb, hdr_len, wl->tkip_bcast_data);
+		if (group_key && key_idx < NUM_GROUP_KEYS && wl->tkip_bcast_data[key_idx])
+			err = wl->tkipmodops->decrypt_mpdu(skb, hdr_len,
+				wl->tkip_bcast_data[key_idx]);
 		else if (!group_key && wl->tkip_ucast_data)
 			err = wl->tkipmodops->decrypt_mpdu(skb, hdr_len, wl->tkip_ucast_data);
 	}
@@ -1828,13 +1944,14 @@
 		uint8 keybuf[8];
 		if (group_key) {
 			if (key->len) {
-				if (!wl->tkip_bcast_data) {
+				if (!wl->tkip_bcast_data[key->id]) {
 					WL_WSEC(("Init TKIP Bcast Module\n"));
 					WL_UNLOCK(wl);
-					wl->tkip_bcast_data = wl->tkipmodops->init(key->id);
+					wl->tkip_bcast_data[key->id] =
+						wl->tkipmodops->init(key->id);
 					WL_LOCK(wl);
 				}
-				if (wl->tkip_bcast_data) {
+				if (wl->tkip_bcast_data[key->id]) {
 					WL_WSEC(("TKIP SET BROADCAST KEY******************\n"));
 					bzero(rxseq, IW_ENCODE_SEQ_MAX_SIZE);
 					bcopy(&key->rxiv, rxseq, 6);
@@ -1842,14 +1959,14 @@
 					bcopy(&key->data[16], &key->data[24], sizeof(keybuf));
 					bcopy(keybuf, &key->data[16], sizeof(keybuf));
 					wl->tkipmodops->set_key(&key->data, key->len,
-						(uint8 *)&key->rxiv, wl->tkip_bcast_data);
+						(uint8 *)&key->rxiv, wl->tkip_bcast_data[key->id]);
 				}
 			}
 			else {
-				if (wl->tkip_bcast_data) {
+				if (wl->tkip_bcast_data[key->id]) {
 					WL_WSEC(("Deinit TKIP Bcast Module\n"));
-					wl->tkipmodops->deinit(wl->tkip_bcast_data);
-					wl->tkip_bcast_data = NULL;
+					wl->tkipmodops->deinit(wl->tkip_bcast_data[key->id]);
+					wl->tkip_bcast_data[key->id] = NULL;
 				}
 			}
 		}
@@ -1892,10 +2009,15 @@
 {
 #if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 14)
 	char debug_buf[512];
+	int idx;
 	if (wl->tkipmodops) {
-		if (group_key && wl->tkip_bcast_data)
-			wl->tkipmodops->print_stats(debug_buf, wl->tkip_bcast_data);
-		else if (!group_key && wl->tkip_ucast_data)
+		if (group_key) {
+			for (idx = 0; idx < NUM_GROUP_KEYS; idx++) {
+				if (wl->tkip_bcast_data[idx])
+					wl->tkipmodops->print_stats(debug_buf,
+						wl->tkip_bcast_data[idx]);
+			}
+		} else if (!group_key && wl->tkip_ucast_data)
 			wl->tkipmodops->print_stats(debug_buf, wl->tkip_ucast_data);
 		else
 			return;
@@ -1904,6 +2026,101 @@
 #endif 
 }
 
+#if defined(WL_CONFIG_RFKILL_INPUT)
+
+static int
+wl_sw_toggle_radio(void *data, enum rfkill_state state)
+{
+	wl_info_t *wl = data;
+	mbool cur_state;
+	uint32 radioval = WL_RADIO_SW_DISABLE << 16;
+
+	if (wlc_get(wl->wlc, WLC_GET_RADIO, &cur_state) < 0) {
+		WL_ERROR(("%s: WLC_GET_RADIO failed\n", __FUNCTION__));
+	}
+
+	switch (state) {
+	case RFKILL_STATE_SOFT_BLOCKED:
+
+		if (!mboolisset(cur_state, WL_RADIO_SW_DISABLE)) {
+			WL_ERROR(("%s: => Disable radio\n", __FUNCTION__));
+		}
+		return 0;
+	case RFKILL_STATE_UNBLOCKED:
+
+		if (mboolisset(cur_state, WL_RADIO_SW_DISABLE)) {
+			radioval |= WL_RADIO_SW_DISABLE;
+			WL_ERROR(("%s: => Enable radio\n", __FUNCTION__));
+		}
+		return 0;
+	default:
+		return -EINVAL;
+	}
+	if (wlc_set(wl->wlc, WLC_SET_RADIO, radioval) < 0)
+			WL_ERROR(("%s: SET_RADIO failed\n", __FUNCTION__));
+}
+
+static int
+wl_init_rfkill(wl_info_t *wl)
+{
+	int status;
+	wl->wl_rfkill.rfkill = rfkill_allocate(&wl->dev->dev, RFKILL_TYPE_WLAN);
+	if (!wl->wl_rfkill.rfkill) {
+		WL_ERROR(("%s: RFKILL: Failed to allocate rfkill\n", __FUNCTION__));
+		return -ENOMEM;
+	}
+
+	snprintf(wl->wl_rfkill.rfkill_name, sizeof(wl->wl_rfkill.rfkill_name),
+		"brcmwl-%d", wl->pub->unit);
+
+	if (wlc_get(wl->wlc, WLC_GET_RADIO, &status) < 0)
+		WL_ERROR(("%s: WLC_GET_RADIO failed\n", __FUNCTION__));
+
+	wl->wl_rfkill.rfkill->name = wl->wl_rfkill.rfkill_name;
+	wl->wl_rfkill.rfkill->data = wl;
+	wl->wl_rfkill.rfkill->toggle_radio = wl_sw_toggle_radio;
+
+	if (status & WL_RADIO_HW_DISABLE)
+		wl->wl_rfkill.rfkill->state = RFKILL_STATE_HARD_BLOCKED;
+	else
+		wl->wl_rfkill.rfkill->state = RFKILL_STATE_UNBLOCKED;
+
+	wl->wl_rfkill.rfkill->user_claim_unsupported = 1;
+
+	if (rfkill_register(wl->wl_rfkill.rfkill)) {
+		WL_ERROR(("%s: rfkill_register failed! \n", __FUNCTION__));
+		rfkill_free(wl->wl_rfkill.rfkill);
+	}
+	wl->wl_rfkill.registered = TRUE;
+	return 0;
+}
+
+static void
+wl_uninit_rfkill(wl_info_t *wl)
+{
+	if (wl->wl_rfkill.registered) {
+		rfkill_unregister(wl->wl_rfkill.rfkill);
+		wl->wl_rfkill.registered = FALSE;
+		wl->wl_rfkill.rfkill = NULL;
+	}
+}
+
+static void
+wl_force_kill(wl_task_t *task)
+{
+	wl_info_t *wl = (wl_info_t *) task->context;
+
+	ASSERT(wl);
+	if (wl->last_phyind)
+		rfkill_force_state(wl->wl_rfkill.rfkill, RFKILL_STATE_HARD_BLOCKED);
+	else
+		rfkill_force_state(wl->wl_rfkill.rfkill, RFKILL_STATE_UNBLOCKED);
+
+	MFREE(wl->osh, task, sizeof(wl_task_t));
+	atomic_dec(&wl->callbacks);
+}
+#endif 
+
 static int
 wl_linux_watchdog(void *ctx)
 {
@@ -1924,30 +2141,30 @@
 #ifdef CONFIG_WIRELESS_EXT
 		wstats = &wl->wstats_watchdog[id];
 #endif
-		stats->rx_packets = WLCNTVAL(wl->pub->_cnt.rxframe);
-		stats->tx_packets = WLCNTVAL(wl->pub->_cnt.txframe);
-		stats->rx_bytes = WLCNTVAL(wl->pub->_cnt.rxbyte);
-		stats->tx_bytes = WLCNTVAL(wl->pub->_cnt.txbyte);
-		stats->rx_errors = WLCNTVAL(wl->pub->_cnt.rxerror);
-		stats->tx_errors = WLCNTVAL(wl->pub->_cnt.txerror);
+		stats->rx_packets = WLCNTVAL(wl->pub->_cnt->rxframe);
+		stats->tx_packets = WLCNTVAL(wl->pub->_cnt->txframe);
+		stats->rx_bytes = WLCNTVAL(wl->pub->_cnt->rxbyte);
+		stats->tx_bytes = WLCNTVAL(wl->pub->_cnt->txbyte);
+		stats->rx_errors = WLCNTVAL(wl->pub->_cnt->rxerror);
+		stats->tx_errors = WLCNTVAL(wl->pub->_cnt->txerror);
 		stats->collisions = 0;
 
 		stats->rx_length_errors = 0;
-		stats->rx_over_errors = WLCNTVAL(wl->pub->_cnt.rxoflo);
-		stats->rx_crc_errors = WLCNTVAL(wl->pub->_cnt.rxcrc);
+		stats->rx_over_errors = WLCNTVAL(wl->pub->_cnt->rxoflo);
+		stats->rx_crc_errors = WLCNTVAL(wl->pub->_cnt->rxcrc);
 		stats->rx_frame_errors = 0;
-		stats->rx_fifo_errors = WLCNTVAL(wl->pub->_cnt.rxoflo);
+		stats->rx_fifo_errors = WLCNTVAL(wl->pub->_cnt->rxoflo);
 		stats->rx_missed_errors = 0;
 
-		stats->tx_fifo_errors = WLCNTVAL(wl->pub->_cnt.txuflo);
+		stats->tx_fifo_errors = WLCNTVAL(wl->pub->_cnt->txuflo);
 #ifdef CONFIG_WIRELESS_EXT
 #if WIRELESS_EXT > 11
 		wstats->discard.nwid = 0;
-		wstats->discard.code = WLCNTVAL(wl->pub->_cnt.rxundec);
-		wstats->discard.fragment = WLCNTVAL(wl->pub->_cnt.rxfragerr);
-		wstats->discard.retries = WLCNTVAL(wl->pub->_cnt.txfail);
-		wstats->discard.misc = WLCNTVAL(wl->pub->_cnt.rxrunt) +
-			WLCNTVAL(wl->pub->_cnt.rxgiant);
+		wstats->discard.code = WLCNTVAL(wl->pub->_cnt->rxundec);
+		wstats->discard.fragment = WLCNTVAL(wl->pub->_cnt->rxfragerr);
+		wstats->discard.retries = WLCNTVAL(wl->pub->_cnt->txfail);
+		wstats->discard.misc = WLCNTVAL(wl->pub->_cnt->rxrunt) +
+			WLCNTVAL(wl->pub->_cnt->rxgiant);
 
 		wstats->miss.beacon = 0;
 #endif 

=== modified file 'src/src/wl/sys/wl_linux.h'
--- src/src/wl/sys/wl_linux.h	2009-05-11 16:04:29 +0000
+++ src/src/wl/sys/wl_linux.h	2010-02-14 19:58:58 +0000
@@ -1,28 +1,15 @@
 /*
  * wl_linux.c exported functions and definitions
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: wl_linux.h,v 1.22.2.3 2009/02/27 02:04:03 Exp $
+ * $Id: wl_linux.h,v 1.27.2.4.4.1 2009/11/18 18:51:21 Exp $
  */
 
 #ifndef _wl_linux_h_
@@ -58,13 +45,17 @@
 	struct wl_if *next;
 	struct wl_info *wl;		
 	struct net_device *dev;		
-	int type;			
 	struct wlc_if *wlcif;		
-	struct ether_addr remote;	
 	uint subunit;			
 	bool dev_registed;		
 } wl_if_t;
 
+struct rfkill_stuff {
+	struct rfkill *rfkill;
+	char rfkill_name[32];
+	char registered;
+};
+
 struct wl_info {
 	wlc_pub_t	*pub;		
 	void		*wlc;		
@@ -72,12 +63,11 @@
 	struct net_device *dev;		
 	spinlock_t	lock;		
 	spinlock_t	isr_lock;	
-	uint		bustype;	
+	uint		bcm_bustype;	
 	bool		piomode;	
 	void *regsva;			
 	struct net_device_stats stats;	
 	wl_if_t *if_list;		
-	struct wl_info *next;		
 	atomic_t callbacks;		
 	struct wl_timer *timers;	
 	struct tasklet_struct tasklet;	
@@ -85,10 +75,15 @@
 	bool		resched;	
 	uint32		pci_psstate[16];	
 #if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 14)
+#define NUM_GROUP_KEYS 4
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 29)
+	struct lib80211_crypto_ops *tkipmodops;
+#else
 	struct ieee80211_crypto_ops *tkipmodops;	
+#endif
 	struct ieee80211_tkip_data  *tkip_ucast_data;
-	struct ieee80211_tkip_data  *tkip_bcast_data;
-#endif
+	struct ieee80211_tkip_data  *tkip_bcast_data[NUM_GROUP_KEYS];
+#endif 
 
 	uint	stats_id;		
 
@@ -98,7 +93,10 @@
 	struct iw_statistics wstats;
 	int		phy_noise;
 #endif 
-
+#if defined(WL_CONFIG_RFKILL_INPUT)
+	struct rfkill_stuff wl_rfkill;
+	mbool last_phyind;
+#endif 
 };
 
 #define WL_LOCK(wl)	spin_lock_bh(&(wl)->lock)

=== modified file 'src/src/wl/sys/wlc_key.h'
--- src/src/wl/sys/wlc_key.h	2009-05-11 16:04:29 +0000
+++ src/src/wl/sys/wlc_key.h	2010-02-14 19:58:58 +0000
@@ -3,28 +3,15 @@
  * and exported functions for
  * Broadcom 802.11abg Networking Device Driver
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: wlc_key.h,v 1.44.2.5 2008/08/22 00:37:51 Exp $
+ * $Id: wlc_key.h,v 1.58.2.2.4.1 2009/12/02 01:32:58 Exp $
  */
 
 #ifndef _wlc_key_h_

=== modified file 'src/src/wl/sys/wlc_pub.h'
--- src/src/wl/sys/wlc_pub.h	2009-05-11 16:04:29 +0000
+++ src/src/wl/sys/wlc_pub.h	2010-02-14 19:58:58 +0000
@@ -2,52 +2,34 @@
  * Common (OS-independent) definitions for
  * Broadcom 802.11abg Networking Device Driver
  *
- * Copyright 2008, Broadcom Corporation
+ * Copyright (C) 2010, Broadcom Corporation
  * All Rights Reserved.
  * 
- *  	Unless you and Broadcom execute a separate written software license
- * agreement governing use of this software, this software is licensed to you
- * under the terms of the GNU General Public License version 2, available at
- * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html (the "GPL"), with the
- * following added to such license:
- *      As a special exception, the copyright holders of this software give you
- * permission to link this software with independent modules, regardless of the
- * license terms of these independent modules, and to copy and distribute the
- * resulting executable under terms of your choice, provided that you also meet,
- * for each linked independent module, the terms and conditions of the license
- * of that module. An independent module is a module which is not derived from
- * this software.
- *
  * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
  * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
  * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
  * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
  *
- * $Id: wlc_pub.h,v 1.293.2.36 2009/01/23 22:38:41 Exp $
+ * $Id: wlc_pub.h,v 1.392.2.6 2009/10/30 06:21:23 Exp $
  */
 
 #ifndef _wlc_pub_h_
 #define _wlc_pub_h_
 
-#if defined(__GNUC__)
-#define PACKED  __attribute__((packed))
-#else
-#define PACKED
-#endif
-
-#define	MAX_TIMERS	(27 + (2 * WLC_MAXDPT))		
+#define	MAX_TIMERS	(29 + (2 * WLC_MAXDPT))		
 
 #define	WLC_NUMRATES	16	
 #define	MAXMULTILIST	32	
 #define	D11_PHY_HDR_LEN	6	
 
+#ifndef LINUX_WLUSER_POSTMOGRIFY_REMOVAL
+
 #define	PHY_TYPE_A	0	
 #define	PHY_TYPE_G	2	
 #define	PHY_TYPE_N	4	
 #define	PHY_TYPE_LP	5	
 #define	PHY_TYPE_SSN	6	
-#define	PHY_TYPE_QN	7	
-#define	PHY_TYPE_NULL	0xf	
+#define	PHY_TYPE_LCN	8	
 
 #define WLC_10_MHZ	10	
 #define WLC_20_MHZ	20	
@@ -56,6 +38,7 @@
 #define CHSPEC_WLC_BW(chanspec)	(CHSPEC_IS40(chanspec) ? WLC_40_MHZ : \
 				 CHSPEC_IS20(chanspec) ? WLC_20_MHZ : \
 							 WLC_10_MHZ)
+#endif 
 
 #define	WLC_RSSI_MINVAL		-200	
 #define	WLC_RSSI_NO_SIGNAL	-91	
@@ -66,6 +49,25 @@
 #define	WLC_RSSI_EXCELLENT	-57	
 #define	WLC_RSSI_INVALID	 0	
 
+typedef struct wlc_tunables {
+	int ntxd;			
+	int nrxd;			
+	int rxbufsz;		
+	int nrxbufpost;		
+	int maxscb;			
+	int ampdunummpdu;	
+	int maxpktcb;		
+	int maxdpt;			
+	int maxucodebss;	
+	int maxucodebss4;	
+	int maxbss;			
+	int datahiwat;		
+	int ampdudatahiwat;	
+	int rxbnd;			
+	int txsbnd;			
+	int memreserved;	
+} wlc_tunables_t;
+
 typedef struct wlc_rateset {
 	uint	count;			
 	uint8	rates[WLC_NUMRATES];	
@@ -80,6 +82,7 @@
 	uint8 unicast[4];	
 	uint8 acount;		
 	uint8 auth[4];		
+	uint8 PAD[4];		
 };
 
 typedef void *wlc_pkt_t;
@@ -100,6 +103,7 @@
 	uint8		SSID_len;	
 	uint8		SSID[32];	
 	int16		RSSI;		
+	int16		SNR;		
 	uint16		beacon_period;	
 	uint16		atim_window;	
 	chanspec_t	chanspec;	
@@ -116,6 +120,9 @@
 	uint8		wme_qosinfo;	
 	struct rsn_parms wpa;
 	struct rsn_parms wpa2;
+#ifdef BCMWAPI_WAI
+	struct rsn_parms wapi;
+#endif 
 	uint16		qbss_load_aac;	
 
 	uint8		qbss_load_chan_free;	
@@ -123,6 +130,8 @@
 	uint8		wpacfg;		
 } wlc_bss_info_t;
 
+#ifndef LINUX_WLUSER_POSTMOGRIFY_REMOVAL
+
 struct wlc_if;
 
 #define WLC_ENOIOCTL	1 
@@ -135,6 +144,7 @@
 #define WLC_ENOMEM	8 
 #define WLC_EBUSY	9 
 
+#define IOVF_MFG	(1<<3)  
 #define IOVF_WHL	(1<<4)	
 #define IOVF_NTRL	(1<<5)	
 
@@ -158,8 +168,10 @@
 typedef int (*iovar_fn_t)(void *handle, const bcm_iovar_t *vi, uint32 actionid,
 	const char *name, void *params, uint plen, void *arg, int alen,
 	int vsize, struct wlc_if *wlcif);
+#endif 
 
 typedef struct wlc_pub {
+	void		*wlc;
 	uint		unit;			
 	uint		corerev;		
 	osl_t		*osh;			
@@ -167,6 +179,7 @@
 	char		*vars;			
 	bool		up;			
 	bool		hw_off;			
+	wlc_tunables_t *tunables;	
 	bool		hw_up;			
 	bool		_piomode;		 
 	uint		_nbands;		
@@ -179,12 +192,17 @@
 	bool		_assoc_recreate;	
 	int		_wme;			
 	uint8		_mbss;			
+#ifdef WLBDD
+	bool		_bdd;			
+#endif
+#ifdef WLP2P
+	bool		_p2p;			
+#endif
 	bool		allmulti;		
-	bool		BSS;			
 	bool		associated;		
 
-	bool		phytest_on;		
-	bool		bf_preempt;		
+	bool            phytest_on;             
+	bool		bf_preempt_4306;	
 	uint		txqstopped;		
 
 	bool		_ampdu;			
@@ -194,17 +212,12 @@
 	int		_n_reqd;		
 	int8		_coex;			
 
-	bool		_priofc;		
+	bool		_priofc;	
 
 	struct ether_addr	cur_etheraddr;	
-	struct ether_addr	multicast[MAXMULTILIST]; 
+
+	struct ether_addr	*multicast; 
 	uint		nmulticast;		
-	pmkid_cand_t	pmkid_cand[MAXPMKID];	
-	uint		npmkid_cand;		
-	pmkid_t		pmkid[MAXPMKID];	
-	uint		npmkid;			
-
-	wlc_bss_info_t	current_bss;		
 
 	uint32		wlfeatureflag;		
 	int		psq_pkts_total;		
@@ -213,9 +226,6 @@
 
 	uint16		txmaxpkts;		
 
-	int8		txpwr_local_max;	
-	uint8		txpwr_local_constraint;	
-
 	uint32		swdecrypt;		
 
 	int 		bcmerror;		
@@ -228,14 +238,18 @@
 	uint8		sromrev;		
 	uint32		boardflags;		
 	uint32		boardflags2;		
-	uint8		antsel_type;		
-	bool		antsel_avail;           
-
-	uint32 		radar;			
-
-	wl_cnt_t	_cnt;			
-	wl_wme_cnt_t	_wme_cnt;		
-
+
+	wl_cnt_t	*_cnt;			
+	wl_wme_cnt_t	*_wme_cnt;		
+
+	bool		_win7;			
+	bool		_extsta;		
+	bool		_pkt_filter;		
+
+	bool		_lmac;			
+
+	uint16		bt_period; 		
+	bool		phy_11ncapable;		
 } wlc_pub_t;
 
 typedef struct	wl_rxsts {
@@ -252,9 +266,12 @@
 	uint	preamble;		
 	uint	encoding;		
 	uint	nfrmtype;		
+	struct wl_if *wlif;	
 } wl_rxsts_t;
 
 struct wlc_info;
+struct wlc_hw_info;
+struct wlc_bsscfg;
 struct wlc_if;
 
 #define	AP_ENAB(pub)	(0)
@@ -264,6 +281,8 @@
 #define STA_ONLY(pub)	(!AP_ENAB(pub))
 #define AP_ONLY(pub)	(AP_ENAB(pub) && !APSTA_ENAB(pub))
 
+#ifndef LINUX_WLUSER_POSTMOGRIFY_REMOVAL
+
 #define WLC_PREC_BMP_ALL		MAXBITVAL(WLC_PREC_COUNT)
 
 #define WLC_PREC_BMP_AC_BE	(NBITVAL(WLC_PRIO_TO_PREC(PRIO_8021D_BE)) |	\
@@ -283,8 +302,10 @@
 				NBITVAL(WLC_PRIO_TO_PREC(PRIO_8021D_NC)) |	\
 				NBITVAL(WLC_PRIO_TO_HI_PREC(PRIO_8021D_NC)))
 
+#endif 
+
 #define WME_ENAB(pub) ((pub)->_wme != OFF)
-#define WME_AUTO(wlc) ((wlc)->pub._wme == AUTO)
+#define WME_AUTO(wlc) ((wlc)->pub->_wme == AUTO)
 
 #define WLC_USE_COREFLAGS	0xffffffff	
 
@@ -295,6 +316,8 @@
 #define WLCNTSET(a,value)	((a) = (value)) 
 #define WLCNTVAL(a)		(a)	
 
+#ifndef LINUX_WLUSER_POSTMOGRIFY_REMOVAL
+
 extern void * wlc_attach(void *wl, uint16 vendor, uint16 device, uint unit, bool piomode,
 	osl_t *osh, void *regsva, uint bustype, void *btparam, uint *perr);
 extern uint wlc_detach(struct wlc_info *wlc);
@@ -322,13 +345,20 @@
 extern int wlc_ioctl(struct wlc_info *wlc, int cmd, void *arg, int len, struct wlc_if *wlcif);
 
 extern void wlc_statsupd(struct wlc_info *wlc);
-
+#endif 
+
+extern wlc_pub_t *wlc_pub(void *wlc);
+
+#ifndef LINUX_WLUSER_POSTMOGRIFY_REMOVAL
 extern int wlc_module_register(wlc_pub_t *pub, const bcm_iovar_t *iovars,
                                const char *name, void *hdl, iovar_fn_t iovar_fn,
                                watchdog_fn_t watchdog_fn, down_fn_t down_fn);
 extern int wlc_module_unregister(wlc_pub_t *pub, const char *name, void *hdl);
-
-#define WLC_RPCTX_PARAMS	32
-
-#undef PACKED
+#endif 
+
+#ifndef LINUX_WLUSER_POSTMOGRIFY_REMOVAL
+
+#define WLC_RPCTX_PARAMS        32
+
+#endif 
 #endif 

